function ___$insertStyle(css) {
  if (!css) {
    return;
  }
  if (typeof window === 'undefined') {
    return;
  }

  var style = document.createElement('style');

  style.setAttribute('type', 'text/css');
  style.innerHTML = css;
  document.head.appendChild(style);
  return css;
}

import _toConsumableArray from '@babel/runtime/helpers/toConsumableArray';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import _assertThisInitialized from '@babel/runtime/helpers/assertThisInitialized';
import _inherits from '@babel/runtime/helpers/inherits';
import React, { useState } from 'react';
import _, { includes } from 'lodash';
import shortid from 'shortid';
import withGracefulUnmount from 'react-graceful-unmount';
import store from 'store';
import ROSLIB from 'roslib';
import Amphion from 'amphion';
import { VIZ_TYPE_IMAGE, MESSAGE_TYPE_IMAGE, VIZ_TYPE_LASERSCAN, MESSAGE_TYPE_LASERSCAN, VIZ_TYPE_MAP, MESSAGE_TYPE_OCCUPANCYGRID, VIZ_TYPE_MARKER, MESSAGE_TYPE_MARKER, VIZ_TYPE_MARKERARRAY, MESSAGE_TYPE_MARKERARRAY, VIZ_TYPE_INTERACTIVEMARKER, MESSAGE_TYPE_INTERACTIVEMARKER, MESSAGE_TYPE_INTERACTIVEMARKER_UPDATE, MESSAGE_TYPE_INTERACTIVEMARKER_FEEDBACK, VIZ_TYPE_ODOMETRY, MESSAGE_TYPE_ODOMETRY, VIZ_TYPE_PATH, MESSAGE_TYPE_PATH, VIZ_TYPE_POINT, MESSAGE_TYPE_POINTSTAMPED, VIZ_TYPE_POINTCLOUD, MESSAGE_TYPE_POINTCLOUD2, VIZ_TYPE_POSE, MESSAGE_TYPE_POSESTAMPED, VIZ_TYPE_POSEARRAY, MESSAGE_TYPE_POSEARRAY, VIZ_TYPE_RANGE, MESSAGE_TYPE_RANGE, VIZ_TYPE_ROBOTMODEL, MESSAGE_TYPE_ROBOT_MODEL, VIZ_TYPE_TF, VIZ_TYPE_WRENCH, MESSAGE_TYPE_WRENCHSTAMPED, MESSAGE_TYPE_TF, MESSAGE_TYPE_TF2, DEFAULT_OPTIONS_SCENE, COLOR_TRANSFORMERS, INTENSITY_CHANNEL_OPTIONS, AXES, LASERSCAN_STYLES, DEFAULT_OPTIONS_LASERSCAN, MAP_COLOR_SCHEMES, DEFAULT_OPTIONS_MAP, DEFAULT_OPTIONS_MARKER, DEFAULT_OPTIONS_ARROW, DEFAULT_OPTIONS_FLATARROW, DEFAULT_OPTIONS_AXES, OBJECT_TYPE_AXES, OBJECT_TYPE_FLAT_ARROW, OBJECT_TYPE_ARROW, DEFAULT_OPTIONS_ODOMETRY, DEFAULT_OPTIONS_PATH, DEFAULT_OPTIONS_POSE, POINTCLOUD_COLOR_CHANNELS, DEFAULT_OPTIONS_POINTCLOUD, DEFAULT_OPTIONS_RANGE, DEFAULT_OPTIONS_POINT, DEFAULT_OPTIONS_WRENCH, VIZ_TYPE_POLYGON } from 'amphion/src/utils/constants';
import _taggedTemplateLiteral from '@babel/runtime/helpers/taggedTemplateLiteral';
import styled, { css, keyframes } from 'styled-components';
import Select$1 from 'react-select';
import ReactMarkdown from 'react-markdown';
import _slicedToArray from '@babel/runtime/helpers/slicedToArray';
import { Rnd } from 'react-rnd';
import { JsonEditor } from 'jsoneditor-react';
import 'jsoneditor-react/es/editor.min.css';
import ace from 'brace';
import 'brace/mode/json';
import 'brace/theme/xcode';

var iconLineStyle = {
  fill: 'none',
  stroke: '#dc1d30',
  strokeLinecap: 'round',
  strokeLinejoin: 'round',
  strokeWidth: '1.5px'
};
var iconFillStyle = {
  fill: '#dc1d30'
};
var TF_MESSAGE_TYPES = [MESSAGE_TYPE_TF, MESSAGE_TYPE_TF2];
var DOCS_ROOT_URL = 'https://github.com/rapyuta-robotics/zethus/wiki/';
var markerArrayIcon = React.createElement("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 100 100"
}, React.createElement("rect", {
  style: iconLineStyle,
  x: "32.1",
  y: "15.05",
  width: "18.75",
  height: "36.66",
  transform: "translate(74.85 -8.1) rotate(90)"
}), React.createElement("rect", {
  style: iconLineStyle,
  x: "53.84",
  y: "35.93",
  width: "24.72",
  height: "24.72"
}), React.createElement("circle", {
  style: iconLineStyle,
  cx: "35.51",
  cy: "46.59",
  r: "14.07"
}), React.createElement("rect", {
  style: iconLineStyle,
  x: "41.05",
  y: "51.28",
  width: "24.72",
  height: "24.72"
}));
var vizOptions = [{
  type: VIZ_TYPE_IMAGE,
  icon: React.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 100 100"
  }, React.createElement("rect", {
    style: iconLineStyle,
    x: "17.5",
    y: "30",
    width: "65",
    height: "40",
    rx: "2"
  }), React.createElement("polyline", {
    style: iconLineStyle,
    points: "18 67.5 46 49.5 52 55.5 71 42.5 82.5 49.29"
  }), React.createElement("circle", {
    style: iconFillStyle,
    cx: "62",
    cy: "40.5",
    r: "2.5"
  })),
  messageTypes: [MESSAGE_TYPE_IMAGE],
  description: "Creates a container to visualize the image data represented by a sensor_msgs/Image topic.\n    ![](/image/viz/viz-image.png \"\")",
  docsLink: "".concat(DOCS_ROOT_URL, "Image")
}, {
  type: VIZ_TYPE_LASERSCAN,
  icon: React.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 100 100"
  }, React.createElement("path", {
    style: iconLineStyle,
    d: "M20,53.9C33.44,53.23,56.29,43.82,67.05,25"
  }), React.createElement("circle", {
    style: iconFillStyle,
    cx: "77.5",
    cy: "72.5",
    r: "2.5"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "70.67",
    y1: "31.28",
    x2: "77",
    y2: "66.57"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "60.71",
    y1: "43.05",
    x2: "74.29",
    y2: "67.47"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "43.52",
    y1: "53.9",
    x2: "72.48",
    y2: "69.28"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "27.24",
    y1: "59.33",
    x2: "71.57",
    y2: "72"
  })),
  messageTypes: [MESSAGE_TYPE_LASERSCAN],
  description: "Adds a visualization represented by a sensor_msgs/LaserScan topic to the scene.\n    ![](/image/viz/viz-laserscan.png \"\")",
  docsLink: "".concat(DOCS_ROOT_URL, "Laser-Scan")
}, {
  type: VIZ_TYPE_MAP,
  icon: React.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 100 100"
  }, React.createElement("polygon", {
    style: iconLineStyle,
    points: "24.83 26.16 75.17 26.27 84 74.73 16 74.73 24.83 26.16"
  }), React.createElement("polyline", {
    style: iconLineStyle,
    points: "22.9 36.8 61 36.8 55 43 55 54 35 54"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "77.29",
    y1: "37.89",
    x2: "36",
    y2: "50"
  }), React.createElement("polyline", {
    style: iconLineStyle,
    points: "78.21 42.94 64 49 64 62 43 62 43 74.73"
  }), React.createElement("polyline", {
    style: iconLineStyle,
    points: "80.45 55.26 73 68 55 70 55 74.73"
  }), React.createElement("polyline", {
    style: iconLineStyle,
    points: "30.4 74.73 33 67 17.77 64.99"
  }), React.createElement("polyline", {
    style: iconLineStyle,
    points: "31.07 36.8 38 46 33 57 23 57 25 49"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "20.23",
    y1: "51.47",
    x2: "35.69",
    y2: "42.94"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "35.69",
    y1: "26.18",
    x2: "38",
    y2: "36.8"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "51.91",
    y1: "26.16",
    x2: "46.37",
    y2: "36.8"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "61",
    y1: "37",
    x2: "59.67",
    y2: "26.24"
  }), React.createElement("polyline", {
    style: iconLineStyle,
    points: "67.73 26.16 71 35 76.5 33.57"
  })),
  messageTypes: [MESSAGE_TYPE_OCCUPANCYGRID],
  description: "Adds a visualization represented by a nav_msgs/OccupancyGrid topic to the scene.\n    ![](/image/viz/viz-map.png \"\")",
  docsLink: "".concat(DOCS_ROOT_URL, "Map")
}, {
  type: VIZ_TYPE_MARKER,
  icon: React.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 100 100"
  }, React.createElement("rect", {
    style: iconLineStyle,
    x: "24",
    y: "17",
    width: "22",
    height: "43"
  }), React.createElement("circle", {
    style: iconLineStyle,
    cx: "48.5",
    cy: "53.5",
    r: "16.5"
  }), React.createElement("rect", {
    style: iconLineStyle,
    x: "51",
    y: "50",
    width: "29",
    height: "29"
  })),
  messageTypes: [MESSAGE_TYPE_MARKER],
  description: "Adds a visualization represented by a visualization_msgs/Marker or visualization_msgs/MarkerArray topic to the scene.\n    ![](/image/viz/viz-marker.png \"\")",
  docsLink: "".concat(DOCS_ROOT_URL, "Marker")
}, {
  type: VIZ_TYPE_MARKERARRAY,
  icon: markerArrayIcon,
  messageTypes: [MESSAGE_TYPE_MARKERARRAY],
  description: "Adds a visualization represented by a visualization_msgs/Marker or visualization_msgs/MarkerArray topic to the scene.\n    ![](/image/viz/viz-markerarray.png \"\")",
  docsLink: "".concat(DOCS_ROOT_URL, "Marker-Array")
}, {
  type: VIZ_TYPE_INTERACTIVEMARKER,
  icon: markerArrayIcon,
  messageTypes: [MESSAGE_TYPE_INTERACTIVEMARKER],
  additionalMessageTypes: [MESSAGE_TYPE_INTERACTIVEMARKER_UPDATE, MESSAGE_TYPE_INTERACTIVEMARKER_FEEDBACK],
  description: "Adds an interactive visualization represented by a visualization_msgs/InteractiveMarker topic to the scene.\n    ![](/image/viz/viz-markerarray.png \"\")",
  docsLink: "".concat(DOCS_ROOT_URL, "Interactive-Marker")
}, {
  type: VIZ_TYPE_ODOMETRY,
  icon: React.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 100 100"
  }, React.createElement("polyline", {
    style: iconLineStyle,
    points: "27 32 32 29 20 74"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "35",
    y1: "34",
    x2: "32",
    y2: "29"
  }), React.createElement("polyline", {
    style: iconLineStyle,
    points: "44.16 27.83 49.85 26.56 24.3 65.5"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "51.13",
    y1: "32.25",
    x2: "49.85",
    y2: "26.56"
  }), React.createElement("polyline", {
    style: iconLineStyle,
    points: "63.41 27.33 69.22 27.79 33.34 57.47"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "68.76",
    y1: "33.6",
    x2: "69.22",
    y2: "27.79"
  }), React.createElement("polyline", {
    style: iconLineStyle,
    points: "78.81 31.24 84.36 33.01 42.66 53.74"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "82.59",
    y1: "38.57",
    x2: "84.36",
    y2: "33.01"
  })),
  messageTypes: [MESSAGE_TYPE_ODOMETRY],
  description: "Adds a visualization represented by a nav_msgs/Odometry topic to the scene.\n    ![](/image/viz/viz-odometry.png \"\")",
  docsLink: "".concat(DOCS_ROOT_URL, "Odometry"),
  isDisplay: false
}, {
  type: VIZ_TYPE_PATH,
  icon: React.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 100 100"
  }, React.createElement("path", {
    style: iconLineStyle,
    d: "M25,77c-5-21-5-47,15-38s38,10,40-8"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "77",
    y1: "21",
    x2: "83.5",
    y2: "27.5"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "83.5",
    y1: "21",
    x2: "77",
    y2: "27.5"
  })),
  messageTypes: [MESSAGE_TYPE_PATH],
  description: "Adds a visualization represented by a nav_msgs/Path topic to the scene.\n    ![](/image/viz/viz-path.png \"\")",
  docsLink: "".concat(DOCS_ROOT_URL, "Path")
}, {
  type: VIZ_TYPE_POINT,
  icon: React.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 100 100"
  }, React.createElement("circle", {
    style: iconLineStyle,
    cx: "49.4",
    cy: "49.6",
    r: "30.3"
  })),
  messageTypes: [MESSAGE_TYPE_POINTSTAMPED],
  description: "Adds a visualization represented by a geometry_msgs/PointStamped topic to the scene.\n    ![](/image/viz/viz-point.png \"\")",
  docsLink: "".concat(DOCS_ROOT_URL, "Point")
}, {
  type: VIZ_TYPE_POINTCLOUD,
  icon: React.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 100 100"
  }, React.createElement("path", {
    style: iconLineStyle,
    d: "M42.68,38s-4.29-5.07-13-2.12-8.24,10-8.24,10S13.16,53.09,16,59.07s7.55,6.33,9.89,6.33h5.62"
  }), React.createElement("path", {
    style: iconLineStyle,
    d: "M81.33,58.72c0-6.24-8.06-9.62-12.14-8.93,0,0-2.25-9.88-12.66-8.15a13.12,13.12,0,0,0-14-3.12C34,41.47,34.33,48.58,34.33,48.58S26,55.69,28.87,61.67,36.41,68,38.76,68H81.85"
  })),
  messageTypes: [MESSAGE_TYPE_POINTCLOUD2],
  description: "Adds a visualization represented by a sensor_msgs/PointCloud2 topic to the scene.\n    ![](/image/viz/viz-pointcloud.png \"\")",
  docsLink: "".concat(DOCS_ROOT_URL, "Point-Cloud-2")
}, {
  type: VIZ_TYPE_POSE,
  icon: React.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 100 100"
  }, React.createElement("rect", {
    style: iconLineStyle,
    x: "17.72",
    y: "63.34",
    width: "11.42",
    height: "11.42"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "35.84",
    y1: "58.49",
    x2: "78.2",
    y2: "32.71"
  }), React.createElement("polyline", {
    style: iconLineStyle,
    points: "69.2 29.92 79.32 31.85 77.4 41.96"
  })),
  messageTypes: [MESSAGE_TYPE_POSESTAMPED],
  description: "Adds a visualization represented by a geometry_msgs/PoseStamped topic to the scene.\n    ![](/image/viz/viz-pose.png \"\")",
  docsLink: "".concat(DOCS_ROOT_URL, "Pose")
}, {
  type: VIZ_TYPE_POSEARRAY,
  icon: React.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 100 100"
  }, React.createElement("rect", {
    style: iconLineStyle,
    x: "23.14",
    y: "76.1",
    width: "11.42",
    height: "11.42"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "41.65",
    y1: "73.36",
    x2: "83.62",
    y2: "45.47"
  }), React.createElement("polyline", {
    style: iconLineStyle,
    points: "74.62 42.67 84.74 44.6 82.81 54.72"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "23.45",
    y1: "56.06",
    x2: "35.99",
    y2: "16.59"
  }), React.createElement("polyline", {
    style: iconLineStyle,
    points: "27.16 19.86 36.35 15.22 41 24.4"
  }), React.createElement("circle", {
    style: iconLineStyle,
    cx: "21.12",
    cy: "64.75",
    r: "5.04"
  })),
  messageTypes: [MESSAGE_TYPE_POSEARRAY],
  description: "Adds a visualization represented by a geometry_msgs/PoseArray topic to the scene. An array of pose is added to the scene based on the Shape type selected.\n    ![](/image/viz/viz-posearray.png \"\")",
  docsLink: "".concat(DOCS_ROOT_URL, "Pose-Array")
}, {
  type: VIZ_TYPE_RANGE,
  icon: React.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 100 100"
  }, React.createElement("polygon", {
    style: iconLineStyle,
    points: "83.7,58 18.2,74.8 18.2,29.5 83.6,46.2 "
  })),
  messageTypes: [MESSAGE_TYPE_RANGE],
  description: "Adds a visualization represented by a sensor_msgs/Range topic to the scene.\n    ![](/image/viz/viz-range.png \"\")",
  docsLink: "".concat(DOCS_ROOT_URL, "Range")
}, {
  type: VIZ_TYPE_ROBOTMODEL,
  icon: React.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 100 100"
  }, React.createElement("g", null, React.createElement("rect", {
    style: iconLineStyle,
    x: "23.39",
    y: "38.67",
    width: "53.21",
    height: "36.09",
    rx: "7.08"
  })), React.createElement("g", null, React.createElement("circle", {
    style: iconFillStyle,
    cx: "35.09",
    cy: "53.4",
    r: "3.31"
  }), React.createElement("circle", {
    style: iconFillStyle,
    cx: "64.91",
    cy: "53.4",
    r: "3.31"
  })), React.createElement("circle", {
    style: iconFillStyle,
    cx: "50",
    cy: "28.55",
    r: "3.31"
  }), React.createElement("g", null, React.createElement("line", {
    style: iconLineStyle,
    x1: "81.76",
    y1: "46.36",
    x2: "81.76",
    y2: "63.76"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "18.24",
    y1: "64.18",
    x2: "18.24",
    y2: "46.78"
  })), React.createElement("line", {
    style: iconLineStyle,
    x1: "50",
    y1: "38.08",
    x2: "50",
    y2: "31.45"
  }), React.createElement("g", null, React.createElement("path", {
    style: iconFillStyle,
    d: "M38.12,65.42a22.94,22.94,0,0,0,23.76,0"
  }))),
  messageTypes: [MESSAGE_TYPE_ROBOT_MODEL],
  description: "Adds a robot model to the scene from a ros parameter.\n    ![](/image/viz/viz-robotmodel.png \"\")",
  docsLink: "".concat(DOCS_ROOT_URL, "Robot-Model")
}, {
  type: VIZ_TYPE_TF,
  icon: React.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 100 100"
  }, React.createElement("line", {
    style: iconLineStyle,
    x1: "27.34",
    y1: "72.45",
    x2: "12.63",
    y2: "80.75"
  }), React.createElement("polyline", {
    style: iconLineStyle,
    points: "27.34 43.45 27.34 72.45 55.38 72.45"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "65.33",
    y1: "38.54",
    x2: "77.6",
    y2: "44.07"
  }), React.createElement("polyline", {
    style: iconLineStyle,
    points: "49.35 16.48 65.33 38.54 78.74 22.09"
  }), React.createElement("line", {
    style: iconLineStyle,
    x1: "27.34",
    y1: "72.45",
    x2: "63",
    y2: "39.54"
  }), React.createElement("polyline", {
    style: iconLineStyle,
    points: "56.15 39.2 63.38 39.2 62.43 47.7"
  })),
  messageTypes: TF_MESSAGE_TYPES,
  description: "Adds a visualization represented by a tf/tfMessage and tf2_msgs/TFMessage topic to the scene.\n    ![](/image/viz/viz-tf.png \"\")",
  docsLink: "".concat(DOCS_ROOT_URL, "Tf")
}, {
  type: VIZ_TYPE_WRENCH,
  icon: React.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 100 100"
  }, React.createElement("line", {
    x1: "30.74",
    y1: "72.45",
    x2: "72.42",
    y2: "16.7",
    style: iconLineStyle
  }), React.createElement("polyline", {
    points: "63.04 17.46 73.14 15.47 75.13 25.58",
    style: iconLineStyle
  }), React.createElement("path", {
    d: "M29.85,56.69a42.48,42.48,0,0,1,8.32,3.72c10.54,6.09,16.7,15.16,13.75,20.27S38,85,27.49,78.9,10.79,63.74,13.74,58.63a6.59,6.59,0,0,1,4.18-2.92",
    style: iconLineStyle
  }), React.createElement("line", {
    x1: "30.5",
    y1: "68.57",
    x2: "33.08",
    y2: "49.47",
    style: iconLineStyle
  }), React.createElement("polyline", {
    points: "27.92 52.19 33.16 48.05 37.04 52.96",
    style: iconLineStyle
  })),
  messageTypes: [MESSAGE_TYPE_WRENCHSTAMPED],
  description: "Adds a visualization represented by a geometry_msgs/WrenchStamped topic to the scene.\n    ![](/image/viz/viz-wrench.png \"\")",
  docsLink: "".concat(DOCS_ROOT_URL, "Wrench")
}];

var ROS_SOCKET_STATUSES = {
  INITIAL: 'Idle. Not Connected',
  CONNECTING: 'Connecting',
  CONNECTED: 'Connected successfully',
  CONNECTION_ERROR: 'Error in connection'
};
var getTfTopics = function getTfTopics(rosTopics) {
  return _.filter(rosTopics, function (t) {
    return _.includes(TF_MESSAGE_TYPES, t.messageType);
  });
};
var stopPropagation = function stopPropagation(e) {
  return e.stopPropagation();
};
var DEFAULT_CONFIG = {
  panels: {
    sidebar: {
      display: true
    }
  },
  ros: {
    endpoint: 'ws://localhost:9090'
  },
  visualizations: [],
  globalOptions: {
    display: true,
    backgroundColor: {
      display: true,
      value: DEFAULT_OPTIONS_SCENE.backgroundColor
    },
    fixedFrame: {
      display: true,
      value: 'world'
    },
    grid: {
      display: true,
      size: DEFAULT_OPTIONS_SCENE.gridSize,
      divisions: DEFAULT_OPTIONS_SCENE.gridDivisions,
      color: DEFAULT_OPTIONS_SCENE.gridColor,
      centerlineColor: DEFAULT_OPTIONS_SCENE.gridCenterlineColor
    }
  },
  tools: {
    mode: 'controls',
    controls: {
      display: false,
      enabled: true
    },
    measure: {
      display: false
    },
    custom: []
  }
};
function updateOptionsUtil(e) {
  var _this$props = this.props,
      key = _this$props.options.key,
      updateVizOptions = _this$props.updateVizOptions;
  var _e$target = e.target,
      checked = _e$target.checked,
      optionId = _e$target.dataset.id,
      value = _e$target.value;
  updateVizOptions(key, _defineProperty({}, optionId, _.has(e.target, 'checked') ? checked : value));
}

var COLOR_PRIMARY = '#dc1d30';
var COLOR_BLUE = '#013c89';
var COLOR_RED = '#dc1d30';
var COLOR_GREY_LIGHT_1 = '#f6f6f6';
var COLOR_GREY_LIGHT_2 = '#dddddd';
var COLOR_GREY_TEXT_2 = '#444444';
var COLOR_GREY_TEXT_3 = '#666666';
var COLOR_GREY_TEXT_4 = '#888888';
var FONT_SIZE_S = '0.7rem';

function _templateObject31() {
  var data = _taggedTemplateLiteral(["\n  border: 0;\n  margin: 0;\n  padding: 0;\n  background-color: transparent;\n  color: ", ";\n  font-size: 16px;\n  text-decoration: underline;\n  &:hover {\n    text-decoration: none;\n  }\n  &[disabled] {\n    color: ", ";\n  }\n"]);

  _templateObject31 = function _templateObject31() {
    return data;
  };

  return data;
}

function _templateObject30() {
  var data = _taggedTemplateLiteral(["\n  svg {\n    height: 40px;\n    display: block;\n  }\n"]);

  _templateObject30 = function _templateObject30() {
    return data;
  };

  return data;
}

function _templateObject29() {
  var data = _taggedTemplateLiteral(["\n  background-color: #fff;\n  width: 400px;\n  display: flex;\n  flex-direction: column;\n  flex-shrink: 0;\n"]);

  _templateObject29 = function _templateObject29() {
    return data;
  };

  return data;
}

function _templateObject28() {
  var data = _taggedTemplateLiteral(["\n          background-color: #000000;\n        "]);

  _templateObject28 = function _templateObject28() {
    return data;
  };

  return data;
}

function _templateObject27() {
  var data = _taggedTemplateLiteral(["\n          background-color: #ff3e3c;\n        "]);

  _templateObject27 = function _templateObject27() {
    return data;
  };

  return data;
}

function _templateObject26() {
  var data = _taggedTemplateLiteral(["\n          background-color: #f9c351;\n          animation: ", " normal 1s infinite ease-in-out;\n        "]);

  _templateObject26 = function _templateObject26() {
    return data;
  };

  return data;
}

function _templateObject25() {
  var data = _taggedTemplateLiteral(["\n          background-color: #3e991c;\n        "]);

  _templateObject25 = function _templateObject25() {
    return data;
  };

  return data;
}

function _templateObject24() {
  var data = _taggedTemplateLiteral(["\n  width: 8px;\n  height: 8px;\n  border-radius: 4px;\n  margin: 0 10px -2px 0;\n  ", "\n"]);

  _templateObject24 = function _templateObject24() {
    return data;
  };

  return data;
}

function _templateObject23() {
  var data = _taggedTemplateLiteral(["\n  from, to {\n    opacity: 0;\n  }\n\n  50% {\n    opacity: 1;\n  }\n"]);

  _templateObject23 = function _templateObject23() {
    return data;
  };

  return data;
}

function _templateObject22() {
  var data = _taggedTemplateLiteral(["\n  padding: 0 20px;\n"]);

  _templateObject22 = function _templateObject22() {
    return data;
  };

  return data;
}

function _templateObject21() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  min-height: 30px;\n  align-items: center;\n  padding: 3px 0;\n  font-size: ", ";\n\n  ", ", ", " {\n    height: 26px;\n  }\n"]);

  _templateObject21 = function _templateObject21() {
    return data;
  };

  return data;
}

function _templateObject20() {
  var data = _taggedTemplateLiteral(["\n  width: 50%;\n"]);

  _templateObject20 = function _templateObject20() {
    return data;
  };

  return data;
}

function _templateObject19() {
  var data = _taggedTemplateLiteral(["\n  ", "\n"]);

  _templateObject19 = function _templateObject19() {
    return data;
  };

  return data;
}

function _templateObject18() {
  var data = _taggedTemplateLiteral(["\n  ", "\n"]);

  _templateObject18 = function _templateObject18() {
    return data;
  };

  return data;
}

function _templateObject17() {
  var data = _taggedTemplateLiteral(["\n      border: 1px solid ", ";\n    "]);

  _templateObject17 = function _templateObject17() {
    return data;
  };

  return data;
}

function _templateObject16() {
  var data = _taggedTemplateLiteral(["\n  font-size: 14px;\n  color: ", ";\n  display: block;\n  margin: 0 0 5px;\n"]);

  _templateObject16 = function _templateObject16() {
    return data;
  };

  return data;
}

function _templateObject15() {
  var data = _taggedTemplateLiteral(["\n  padding-top: 11px;\n  padding-bottom: 11px;\n"]);

  _templateObject15 = function _templateObject15() {
    return data;
  };

  return data;
}

function _templateObject14() {
  var data = _taggedTemplateLiteral(["\n  border: 0;\n  margin: 0;\n  padding: 6px 20px;\n  border-radius: 4px;\n  color: white;\n  background-color: ", ";\n  font-size: 16px;\n  &[disabled] {\n    background-color: ", ";\n  }\n"]);

  _templateObject14 = function _templateObject14() {
    return data;
  };

  return data;
}

function _templateObject13() {
  var data = _taggedTemplateLiteral(["\n      border: 1px solid ", ";\n      border-bottom: 1px solid #fff;\n    "]);

  _templateObject13 = function _templateObject13() {
    return data;
  };

  return data;
}

function _templateObject12() {
  var data = _taggedTemplateLiteral(["\n  margin: 0 10px -1px;\n  background-color: transparent;\n  border: 1px solid ", ";\n  border-bottom: 1px solid ", ";\n  border-radius: 4px 4px 0 0;\n  color: inherit;\n  padding: 5px 10px 10px;\n  ", "\n"]);

  _templateObject12 = function _templateObject12() {
    return data;
  };

  return data;
}

function _templateObject11() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  border-bottom: 1px solid ", ";\n  flex-shrink: 0;\n"]);

  _templateObject11 = function _templateObject11() {
    return data;
  };

  return data;
}

function _templateObject10() {
  var data = _taggedTemplateLiteral(["\n  padding: 15px 20px;\n"]);

  _templateObject10 = function _templateObject10() {
    return data;
  };

  return data;
}

function _templateObject9() {
  var data = _taggedTemplateLiteral(["\n  width: 0;\n  flex-grow: 1;\n  flex-shrink: 1;\n"]);

  _templateObject9 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  background-color: #000;\n  height: 100vh;\n  overflow-y: hidden;\n  width: 100%;\n"]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = _taggedTemplateLiteral(["\n  flex-grow: 1;\n"]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = _taggedTemplateLiteral(["\n  width: 10px;\n"]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = _taggedTemplateLiteral(["\n  width: 100%;\n  height: 0;\n  border: 0;\n  margin: 0;\n  border-bottom: 1px solid ", ";\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\n  color: ", ";\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  line-height: 1.5;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  cursor: pointer;\n  font-size: inherit;\n  font-family: inherit;\n  outline: 0;\n\n  &:active {\n    outline: 0;\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var Button = styled.button(_templateObject());
var Paragraph = styled.p(_templateObject2());
var Anchor = styled.a(_templateObject3(), COLOR_PRIMARY);
var Separator = styled.hr(_templateObject4(), COLOR_GREY_LIGHT_2);
var Flex = styled.div(_templateObject5());
var FlexSpace = styled.div(_templateObject6());
var FlexGrow = styled.div(_templateObject7());
var PanelWrapper = styled.div(_templateObject8());
var PanelContent = styled.div(_templateObject9());
var Container = styled.div(_templateObject10());
var TabsHeader = styled.div(_templateObject11(), COLOR_GREY_LIGHT_2);
var TabsButton = styled(Button)(_templateObject12(), COLOR_GREY_LIGHT_2, COLOR_GREY_LIGHT_2, function (_ref) {
  var selected = _ref.selected;
  return selected && css(_templateObject13(), COLOR_GREY_LIGHT_2);
});
var ButtonPrimary = styled(Button)(_templateObject14(), COLOR_PRIMARY, COLOR_GREY_LIGHT_2);
var InputWrapper = styled.div(_templateObject15());
var InputLabel = styled.label(_templateObject16(), COLOR_GREY_TEXT_3);
var inputStyles = "\n  height: 32px;\n  width: 100%;\n  flex-grow: 1;\n  flex-shrink: 1;\n  background-color: ".concat(COLOR_GREY_LIGHT_1, ";\n  border: 1px solid ").concat(COLOR_GREY_LIGHT_1, ";\n  color: ").concat(COLOR_GREY_TEXT_2, ";\n  border-radius: 4px;\n  padding: 0 8px;\n  font-size: inherit;\n  font-family: inherit;\n  outline: 0;\n\n  &:active {\n    outline: 0;\n  }\n  :active,\n  :focus {\n    outline: 0;\n    border: 1px solid ").concat(COLOR_BLUE, ";\n  }\n  ").concat(function (_ref2) {
  var error = _ref2.error;
  return error && css(_templateObject17(), COLOR_RED);
}, "\n  [disabled] {\n    cursor: not-allowed;\n  }\n");
var Input = styled.input(_templateObject18(), inputStyles);
var Select = styled.select(_templateObject19(), inputStyles);
var HalfWidth = styled.div(_templateObject20());
var StyledOptionRow = styled.div(_templateObject21(), FONT_SIZE_S, Input, Select);
var OptionContainer = styled.div(_templateObject22());
var twinkle = keyframes(_templateObject23());
var RosStatusIndicator = styled.span(_templateObject24(), function (_ref3) {
  var status = _ref3.status;

  switch (status) {
    case ROS_SOCKET_STATUSES.CONNECTED:
      return css(_templateObject25());

    case ROS_SOCKET_STATUSES.CONNECTING:
      return css(_templateObject26(), twinkle);

    case ROS_SOCKET_STATUSES.CONNECTION_ERROR:
      return css(_templateObject27());

    default:
      return css(_templateObject28());
  }
});
var StyledSidebar = styled.div(_templateObject29());
var StyledLogo = styled(Container)(_templateObject30());
var TextButton = styled(Button)(_templateObject31(), COLOR_PRIMARY, COLOR_GREY_LIGHT_2);

function _templateObject13$1() {
  var data = _taggedTemplateLiteral(["\n  padding-left: 30px;\n"]);

  _templateObject13$1 = function _templateObject13() {
    return data;
  };

  return data;
}

function _templateObject12$1() {
  var data = _taggedTemplateLiteral(["\n  text-align: left;\n  width: 100%;\n  font-size: 16px;\n  border: 0;\n  background: transparent;\n  padding: 10px;\n  display: flex;\n  align-items: center;\n\n  .reactSelect {\n    color: ", ";\n  }\n\n  &:hover {\n    color: ", ";\n    background-color: ", ";\n    .reactSelect {\n      color: ", ";\n    }\n  }\n\n  ", "\n"]);

  _templateObject12$1 = function _templateObject12() {
    return data;
  };

  return data;
}

function _templateObject11$1() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  flex-grow: 1;\n  flex-shrink: 1;\n  height: 0;\n  flex-direction: column;\n"]);

  _templateObject11$1 = function _templateObject11() {
    return data;
  };

  return data;
}

function _templateObject10$1() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  align-items: center;\n  text-transform: uppercase;\n  margin-bottom: 5px;\n"]);

  _templateObject10$1 = function _templateObject10() {
    return data;
  };

  return data;
}

function _templateObject9$1() {
  var data = _taggedTemplateLiteral(["\n  border-left: 1px solid ", ";\n  padding: 0 0 0 20px;\n  flex: 1 0 50%;\n  overflow-y: auto;\n\n  h4 {\n    margin-top: 10px;\n    margin-bottom: 8px;\n    font-size: 22px;\n  }\n\n  img {\n    max-width: 100%;\n  }\n\n  & > div {\n    margin-bottom: 8px;\n  }\n"]);

  _templateObject9$1 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8$1() {
  var data = _taggedTemplateLiteral(["\n  flex: 1 0 50%;\n  overflow-y: auto;\n"]);

  _templateObject8$1 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7$1() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  flex-grow: 1;\n  overflow: hidden;\n"]);

  _templateObject7$1 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6$1() {
  var data = _taggedTemplateLiteral(["\n  padding: 10px;\n  opacity: 0.4;\n  cursor: not-allowed;\n"]);

  _templateObject6$1 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5$1() {
  var data = _taggedTemplateLiteral(["\n  padding-left: 30px;\n  font-style: italic;\n"]);

  _templateObject5$1 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4$1() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  flex-shrink: 0;\n  padding: 10px 0 0;\n\n  button {\n    margin-left: 10px;\n  }\n"]);

  _templateObject4$1 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3$1() {
  var data = _taggedTemplateLiteral(["\n  margin-bottom: 6px;\n  margin-top: 0;\n"]);

  _templateObject3$1 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2$1() {
  var data = _taggedTemplateLiteral(["\n  width: 1000px;\n  margin: 100px auto;\n  height: 600px;\n  background-color: #ffffff;\n  box-shadow: 0 0 40px rgba(0, 0, 0, 0.08);\n  border-radius: 8px;\n  padding: 20px;\n  display: flex;\n  flex-direction: column;\n"]);

  _templateObject2$1 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject$1() {
  var data = _taggedTemplateLiteral(["\n  position: absolute;\n  z-index: 1000;\n  top: 0;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  background-color: rgba(255, 255, 255, 0.9);\n"]);

  _templateObject$1 = function _templateObject() {
    return data;
  };

  return data;
}
var ModalWrapper = styled.div(_templateObject$1());
var ModalContents = styled.div(_templateObject2$1());
var ModalTitle = styled.h2(_templateObject3$1());
var ModalActions = styled.div(_templateObject4$1());
var TypeEmpty = styled(Paragraph)(_templateObject5$1());
var TypeUnsupported = styled(Flex)(_templateObject6$1());
var TypeContainer = styled.div(_templateObject7$1());
var TypeSelection = styled.div(_templateObject8$1());
var TypeInfo = styled.div(_templateObject9$1(), COLOR_GREY_LIGHT_2);
var TypeHeading = styled.h4(_templateObject10$1());
var AddVizForm = styled.form(_templateObject11$1());
var TopicRow = styled(Button)(_templateObject12$1(), COLOR_GREY_TEXT_2, COLOR_PRIMARY, COLOR_GREY_LIGHT_1, COLOR_GREY_TEXT_2, function (_ref) {
  var selected = _ref.selected;
  return selected && "\n    color: ".concat(COLOR_PRIMARY, ";\n    background-color: ").concat(COLOR_GREY_LIGHT_1, ";\n  ");
});
var TypeRow = styled(TopicRow)(_templateObject13$1());

function _templateObject12$2() {
  var data = _taggedTemplateLiteral(["\n      transform: rotate(-90deg);\n    "]);

  _templateObject12$2 = function _templateObject12() {
    return data;
  };

  return data;
}

function _templateObject11$2() {
  var data = _taggedTemplateLiteral(["\n  background-color: transparent;\n  border: 0;\n  padding: 0;\n  margin: 0 3px 0 0;\n  width: 20px;\n  height: 20px;\n  svg {\n    width: 14px;\n  }\n  ", "\n"]);

  _templateObject11$2 = function _templateObject11() {
    return data;
  };

  return data;
}

function _templateObject10$2() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  margin-top: 8px;\n\n  button {\n    background: ", ";\n    border: 0;\n    border-radius: 4px;\n    color: ", ";\n    padding: 5px 10px;\n    font-size: 0.6rem;\n    &:hover {\n      background-color: ", ";\n      color: #ffffff;\n    }\n    & + button {\n      margin-left: 10px;\n    }\n  }\n"]);

  _templateObject10$2 = function _templateObject10() {
    return data;
  };

  return data;
}

function _templateObject9$2() {
  var data = _taggedTemplateLiteral(["\n  padding: 10px 0;\n  border-bottom: 1px solid ", ";\n"]);

  _templateObject9$2 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8$2() {
  var data = _taggedTemplateLiteral(["\n  pointer-events: none;\n  user-select: none;\n"]);

  _templateObject8$2 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7$2() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  font-size: 14px;\n  padding: 2px 5px;\n  min-height: 25px;\n  border-bottom: 1px solid ", ";\n  word-break: break-all;\n  overflow: hidden;\n"]);

  _templateObject7$2 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6$2() {
  var data = _taggedTemplateLiteral(["\n  margin-bottom: 10px;\n  align-items: center;\n"]);

  _templateObject6$2 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5$2() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  background-color: #fff;\n  flex-direction: column;\n  cursor: move;\n  border-radius: 4px;\n  overflow: hidden;\n  height: 100%;\n  width: 100%;\n  border: 1px solid ", ";\n\n  canvas {\n    width: 100%;\n    height: 100%;\n  }\n"]);

  _templateObject5$2 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4$2() {
  var data = _taggedTemplateLiteral(["\n  width: 20px;\n  height: 20px;\n  display: inline-block;\n  background-color: ", ";\n  margin-right: 10px;\n  border-radius: 4px;\n  svg {\n    width: 100%;\n  }\n"]);

  _templateObject4$2 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3$2() {
  var data = _taggedTemplateLiteral(["\n  margin-top: 8px;\n  margin-left: 24px;\n"]);

  _templateObject3$2 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2$2() {
  var data = _taggedTemplateLiteral(["\n  overflow-y: auto;\n"]);

  _templateObject2$2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject$2() {
  var data = _taggedTemplateLiteral(["\n  cursor: pointer;\n  background-color: transparent;\n  border: 0;\n  color: inherit;\n  text-decoration: underline;\n  font-size: inherit;\n  font-family: inherit;\n  &:hover {\n    text-decoration: none;\n  }\n"]);

  _templateObject$2 = function _templateObject() {
    return data;
  };

  return data;
}
var VizImageClose = styled(Button)(_templateObject$2());
var SidebarVizContainer = styled(Container)(_templateObject2$2());
var VizItemContent = styled.div(_templateObject3$2());
var VizItemIcon = styled.div(_templateObject4$2(), COLOR_GREY_LIGHT_1);
var VizImageContainer = styled.div(_templateObject5$2(), COLOR_GREY_LIGHT_2);
var RosStatus = styled(Flex)(_templateObject6$2());
var VizImageHeader = styled.div(_templateObject7$2(), COLOR_GREY_LIGHT_2);
var VizImageName = styled.div(_templateObject8$2());
var VizItem = styled.div(_templateObject9$2(), COLOR_GREY_LIGHT_1);
var VizItemActions = styled.div(_templateObject10$2(), COLOR_GREY_LIGHT_1, COLOR_GREY_TEXT_4, COLOR_PRIMARY);
var VizItemCollapse = styled(Button)(_templateObject11$2(), function (_ref) {
  var collapsed = _ref.collapsed;
  return collapsed && css(_templateObject12$2());
});

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var customStyles = {
  container: function container(provided) {
    return _objectSpread({}, provided, {
      fontSize: '16px',
      width: '250px'
    });
  },
  control: function control(provided) {
    return _objectSpread({}, provided, {
      border: '1px solid #dddddd'
    });
  }
};

var VizTypeItem =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(VizTypeItem, _React$PureComponent);

  function VizTypeItem() {
    _classCallCheck(this, VizTypeItem);

    return _possibleConstructorReturn(this, _getPrototypeOf(VizTypeItem).apply(this, arguments));
  }

  _createClass(VizTypeItem, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          rosParams = _this$props.rosParams,
          selectedViz = _this$props.selectedViz,
          selectViz = _this$props.selectViz,
          topics = _this$props.topics,
          vizDetails = _this$props.vizDetails;

      var topicName = _.get(selectedViz, 'topicName');

      var isRobotmodel = _.get(selectedViz, 'vizType') === VIZ_TYPE_ROBOTMODEL;

      if (vizDetails.type === VIZ_TYPE_ROBOTMODEL) {
        return React.createElement("div", null, React.createElement(TypeHeading, null, React.createElement(VizItemIcon, {
          src: vizDetails.icon,
          alt: ""
        }), vizDetails.type), React.createElement(TypeRow, {
          type: "button",
          selected: isRobotmodel
        }, React.createElement(Select$1, {
          isSearchable: true,
          className: "reactSelect",
          styles: customStyles,
          value: topicName && isRobotmodel ? {
            label: topicName,
            value: topicName
          } : '',
          options: _.map(rosParams, function (p) {
            return {
              label: p,
              value: p
            };
          }),
          onChange: function onChange(_ref) {
            var value = _ref.value;
            selectViz(vizDetails.type, value, '');
          }
        })));
      }

      return React.createElement("div", null, React.createElement(TypeHeading, null, React.createElement(VizItemIcon, {
        src: vizDetails.icon,
        alt: ""
      }), vizDetails.type), _.map(topics, function (topic) {
        return React.createElement(TypeRow, {
          type: "button",
          key: topic.name,
          selected: _.get(selectedViz, 'topicName') === topic.name,
          onClick: function onClick() {
            return selectViz(vizDetails.type, topic.name, topic.messageType);
          }
        }, topic.name);
      }), _.size(topics) === 0 && React.createElement(TypeEmpty, null, "No topics available for the visualization type"));
    }
  }]);

  return VizTypeItem;
}(React.PureComponent);

var VizTypeDetails =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(VizTypeDetails, _React$PureComponent);

  function VizTypeDetails() {
    _classCallCheck(this, VizTypeDetails);

    return _possibleConstructorReturn(this, _getPrototypeOf(VizTypeDetails).apply(this, arguments));
  }

  _createClass(VizTypeDetails, [{
    key: "render",
    value: function render() {
      var vizType = this.props.vizType;

      var _$find = _.find(vizOptions, function (v) {
        return v.type === vizType;
      }),
          description = _$find.description,
          docsLink = _$find.docsLink,
          type = _$find.type;

      return React.createElement(React.Fragment, null, React.createElement("h4", null, type), React.createElement(ReactMarkdown, {
        source: description
      }), React.createElement(Anchor, {
        href: docsLink
      }, "View docs"));
    }
  }]);

  return VizTypeDetails;
}(React.PureComponent);

var VizType =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(VizType, _React$PureComponent);

  function VizType(props) {
    var _this;

    _classCallCheck(this, VizType);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(VizType).call(this, props));
    _this.state = {
      selectedViz: ''
    };
    _this.selectViz = _this.selectViz.bind(_assertThisInitialized(_this));
    _this.onSubmit = _this.onSubmit.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(VizType, [{
    key: "selectViz",
    value: function selectViz(vizType, topicName, messageType) {
      this.setState({
        selectedViz: {
          vizType: vizType,
          topicName: topicName,
          messageType: messageType
        }
      });
    }
  }, {
    key: "onSubmit",
    value: function onSubmit(e) {
      e.preventDefault();
      var selectViz = this.props.selectViz;
      var _this$state$selectedV = this.state.selectedViz,
          messageType = _this$state$selectedV.messageType,
          topicName = _this$state$selectedV.topicName,
          vizType = _this$state$selectedV.vizType;
      selectViz(vizType, topicName, messageType);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var selectedViz = this.state.selectedViz;
      var _this$props = this.props,
          closeModal = _this$props.closeModal,
          rosParams = _this$props.rosParams,
          rosTopics = _this$props.rosTopics;
      return React.createElement(AddVizForm, {
        onSubmit: this.onSubmit
      }, React.createElement(TypeContainer, null, React.createElement(TypeSelection, null, _.map(vizOptions, function (op) {
        return React.createElement(VizTypeItem, {
          selectViz: _this2.selectViz,
          selectedViz: selectedViz,
          rosParams: rosParams,
          key: op.type,
          vizDetails: op,
          topics: _.filter(rosTopics, function (t) {
            return _.includes(op.messageTypes, t.messageType);
          })
        });
      })), React.createElement(TypeInfo, null, selectedViz ? React.createElement(VizTypeDetails, {
        vizType: selectedViz.vizType
      }) : React.createElement("p", null, "No visualization selected.", React.createElement("br", null), "Please choose a visualization on the left to see details"))), React.createElement(ModalActions, null, React.createElement(FlexGrow, null), React.createElement(ButtonPrimary, {
        type: "submit",
        disabled: !selectedViz
      }, "Proceed"), React.createElement(ButtonPrimary, {
        type: "button",
        onClick: closeModal
      }, "Close")));
    }
  }]);

  return VizType;
}(React.PureComponent);

var TopicName =
/*#__PURE__*/
function (_React$Component) {
  _inherits(TopicName, _React$Component);

  function TopicName(props) {
    var _this;

    _classCallCheck(this, TopicName);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TopicName).call(this, props));
    _this.state = {
      selectedViz: ''
    };
    _this.selectViz = _this.selectViz.bind(_assertThisInitialized(_this));
    _this.onSubmit = _this.onSubmit.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(TopicName, [{
    key: "selectViz",
    value: function selectViz(vizType, topicName, messageType) {
      this.setState({
        selectedViz: {
          vizType: vizType,
          topicName: topicName,
          messageType: messageType
        }
      });
    }
  }, {
    key: "onSubmit",
    value: function onSubmit(e) {
      e.preventDefault();
      var selectViz = this.props.selectViz;
      var _this$state$selectedV = this.state.selectedViz,
          messageType = _this$state$selectedV.messageType,
          topicName = _this$state$selectedV.topicName,
          vizType = _this$state$selectedV.vizType;
      selectViz(vizType, topicName, messageType);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          closeModal = _this$props.closeModal,
          rosTopics = _this$props.rosTopics;
      var selectedViz = this.state.selectedViz;
      return React.createElement(AddVizForm, {
        onSubmit: this.onSubmit
      }, React.createElement(TypeContainer, null, React.createElement(TypeSelection, null, _.map(_.sortBy(rosTopics, 'name'), function (_ref) {
        var name = _ref.name,
            messageType = _ref.messageType;

        var vizOption = _.find(vizOptions, function (v) {
          return _.includes(v.messageTypes, messageType);
        });

        return vizOption ? React.createElement(TopicRow, {
          type: "button",
          selected: _.get(selectedViz, 'topicName') === name,
          key: name,
          onClick: function onClick() {
            return _this2.selectViz(vizOption.type, name, messageType);
          }
        }, name, React.createElement(FlexGrow, null), "(", messageType, ")") : React.createElement(TypeUnsupported, {
          key: name
        }, name, React.createElement(FlexGrow, null), "(Unsupported type: ", messageType, ")");
      }))), React.createElement(ModalActions, null, React.createElement(FlexGrow, null), React.createElement(ButtonPrimary, {
        type: "submit",
        disabled: !selectedViz
      }, "Proceed"), React.createElement(ButtonPrimary, {
        type: "button",
        onClick: closeModal
      }, "Close")));
    }
  }]);

  return TopicName;
}(React.Component);

function ownKeys$1(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$1(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$1(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$1(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var statuses = {
  loading: 0,
  loaded: 1,
  error: 2
};

var RobotModelOptions =
/*#__PURE__*/
function (_React$Component) {
  _inherits(RobotModelOptions, _React$Component);

  function RobotModelOptions(props) {
    var _this;

    _classCallCheck(this, RobotModelOptions);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(RobotModelOptions).call(this, props));
    _this.state = {
      name: props.selectedViz.vizType,
      packages: {},
      status: statuses.loading
    };
    _this.onSubmit = _this.onSubmit.bind(_assertThisInitialized(_this));
    _this.getPackages = _this.getPackages.bind(_assertThisInitialized(_this));
    _this.updateName = _this.updateName.bind(_assertThisInitialized(_this));
    _this.updatePackage = _this.updatePackage.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(RobotModelOptions, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.getPackages();
    }
  }, {
    key: "updateName",
    value: function updateName(e) {
      this.setState({
        name: e.target.value
      });
    }
  }, {
    key: "getPackages",
    value: function getPackages() {
      var _this2 = this;

      var _this$props = this.props,
          ros = _this$props.ros,
          topicName = _this$props.selectedViz.topicName;

      try {
        var robotInstance = new Amphion.RobotModel(ros, topicName);
        robotInstance.getPackages(function (packages) {
          _this2.setState({
            packages: _.mapValues(_.keyBy(packages), function (p) {
              return "/".concat(p);
            }),
            status: statuses.loaded
          });
        });
      } catch (e) {
        this.setState({
          status: statuses.error
        });
      }
    }
  }, {
    key: "updatePackage",
    value: function updatePackage(e) {
      var _e$target = e.target,
          packageId = _e$target.dataset.id,
          value = _e$target.value;
      var packages = this.state.packages;
      this.setState({
        packages: _objectSpread$1({}, packages, _defineProperty({}, packageId, value))
      });
    }
  }, {
    key: "onSubmit",
    value: function onSubmit(e) {
      e.preventDefault();
      var _this$props2 = this.props,
          addVisualization = _this$props2.addVisualization,
          selectedViz = _this$props2.selectedViz;
      var _this$state = this.state,
          name = _this$state.name,
          packages = _this$state.packages;
      addVisualization(_objectSpread$1({}, selectedViz, {
        name: name,
        packages: packages
      }));
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$state2 = this.state,
          name = _this$state2.name,
          packages = _this$state2.packages,
          status = _this$state2.status;
      var back = this.props.back;

      if (status === statuses.loading) {
        return React.createElement(Paragraph, null, "Loading list of packages...");
      }

      if (status === statuses.error) {
        return React.createElement(Paragraph, null, "Error occured while fetching packages. Please", ' ', React.createElement(Button, {
          onClick: this.getPackages
        }, "try again"));
      }

      return React.createElement("form", {
        onSubmit: this.onSubmit
      }, React.createElement(InputWrapper, null, React.createElement(InputLabel, null, "Visualization name"), React.createElement(Input, {
        value: name,
        onChange: this.updateName
      })), React.createElement(TypeHeading, null, "Packages"), _.map(packages, function (path, packageName) {
        return React.createElement(InputWrapper, {
          key: packageName
        }, React.createElement(InputLabel, null, packageName), React.createElement(Input, {
          "data-id": packageName,
          value: path,
          onChange: _this3.updatePackage,
          required: true
        }));
      }), React.createElement(ModalActions, null, React.createElement(FlexGrow, null), React.createElement(ButtonPrimary, {
        type: "submit"
      }, "Add Robot model"), React.createElement(ButtonPrimary, {
        type: "button",
        onClick: back
      }, "Back")));
    }
  }]);

  return RobotModelOptions;
}(React.Component);

function ownKeys$2(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$2(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$2(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var GenericOptions =
/*#__PURE__*/
function (_React$Component) {
  _inherits(GenericOptions, _React$Component);

  function GenericOptions(props) {
    var _this;

    _classCallCheck(this, GenericOptions);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(GenericOptions).call(this, props));
    _this.state = {
      name: props.selectedViz.vizType
    };
    _this.onSubmit = _this.onSubmit.bind(_assertThisInitialized(_this));
    _this.updateName = _this.updateName.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(GenericOptions, [{
    key: "updateName",
    value: function updateName(e) {
      this.setState({
        name: e.target.value
      });
    }
  }, {
    key: "onSubmit",
    value: function onSubmit(e) {
      e.preventDefault();
      var _this$props = this.props,
          addVisualization = _this$props.addVisualization,
          selectedViz = _this$props.selectedViz;
      var name = this.state.name;
      addVisualization(_objectSpread$2({}, selectedViz, {
        name: name,
        visible: true
      }));
    }
  }, {
    key: "render",
    value: function render() {
      var name = this.state.name;
      var back = this.props.back;
      return React.createElement("form", {
        onSubmit: this.onSubmit
      }, React.createElement(InputWrapper, null, React.createElement(InputLabel, null, "Visualization name"), React.createElement(Input, {
        value: name,
        onChange: this.updateName
      })), React.createElement(ModalActions, null, React.createElement(FlexGrow, null), React.createElement(ButtonPrimary, {
        type: "submit"
      }, "Add visualization"), React.createElement(ButtonPrimary, {
        type: "button",
        onClick: back
      }, "Back")));
    }
  }]);

  return GenericOptions;
}(React.Component);

var SelectedVizOptionsForm =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(SelectedVizOptionsForm, _React$PureComponent);

  function SelectedVizOptionsForm() {
    _classCallCheck(this, SelectedVizOptionsForm);

    return _possibleConstructorReturn(this, _getPrototypeOf(SelectedVizOptionsForm).apply(this, arguments));
  }

  _createClass(SelectedVizOptionsForm, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          addVisualization = _this$props.addVisualization,
          back = _this$props.back,
          ros = _this$props.ros,
          type = _this$props.selectedViz.vizType,
          selectedViz = _this$props.selectedViz;

      if (type === VIZ_TYPE_ROBOTMODEL) {
        return React.createElement(RobotModelOptions, {
          addVisualization: addVisualization,
          ros: ros,
          selectedViz: selectedViz,
          back: back
        });
      }

      return React.createElement(GenericOptions, {
        addVisualization: addVisualization,
        selectedViz: selectedViz,
        back: back
      });
    }
  }]);

  return SelectedVizOptionsForm;
}(React.PureComponent);

var tabs = {
  vizType: 'Visualization type',
  topicName: 'Topic name'
};

var AddModal =
/*#__PURE__*/
function (_React$Component) {
  _inherits(AddModal, _React$Component);

  function AddModal(props) {
    var _this;

    _classCallCheck(this, AddModal);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(AddModal).call(this, props));
    _this.state = {
      tabType: tabs.vizType,
      selectedViz: ''
    };
    _this.updateTab = _this.updateTab.bind(_assertThisInitialized(_this));
    _this.selectViz = _this.selectViz.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(AddModal, [{
    key: "updateTab",
    value: function updateTab(tabType) {
      this.setState({
        tabType: tabType
      });
    }
  }, {
    key: "selectViz",
    value: function selectViz(vizType, topicName, messageType) {
      this.setState({
        selectedViz: vizType ? {
          vizType: vizType,
          topicName: topicName,
          messageType: messageType
        } : ''
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          addVisualization = _this$props.addVisualization,
          closeModal = _this$props.closeModal,
          ros = _this$props.ros,
          rosParams = _this$props.rosParams,
          rosTopics = _this$props.rosTopics;
      var _this$state = this.state,
          selectedViz = _this$state.selectedViz,
          tabType = _this$state.tabType;
      return React.createElement(ModalWrapper, {
        onClick: closeModal
      }, React.createElement(ModalContents, {
        onClick: stopPropagation
      }, React.createElement(ModalTitle, null, "Add Visualization"), selectedViz ? React.createElement(SelectedVizOptionsForm, {
        addVisualization: addVisualization,
        selectedViz: selectedViz,
        ros: ros,
        back: function back() {
          return _this2.selectViz(null);
        }
      }) : React.createElement(React.Fragment, null, React.createElement(TabsHeader, null, _.map(tabs, function (tabText) {
        return React.createElement(TabsButton, {
          key: tabText,
          type: "button",
          selected: tabType === tabText,
          onClick: function onClick() {
            return _this2.updateTab(tabText);
          }
        }, tabText);
      })), tabType === tabs.vizType ? React.createElement(VizType, {
        selectViz: this.selectViz,
        rosTopics: rosTopics,
        rosParams: rosParams,
        closeModal: closeModal
      }) : React.createElement(TopicName, {
        selectViz: this.selectViz,
        rosTopics: rosTopics,
        closeModal: closeModal
      }))));
    }
  }]);

  return AddModal;
}(React.Component);

var OptionRow = function OptionRow(_ref) {
  var label = _ref.label,
      children = _ref.children;
  return React.createElement(StyledOptionRow, null, React.createElement(HalfWidth, null, label, ":"), React.createElement(HalfWidth, null, children));
};

function _templateObject$3() {
  var data = _taggedTemplateLiteral(["\n  font-size: 14px;\n"]);

  _templateObject$3 = function _templateObject() {
    return data;
  };

  return data;
}
var EditConfigButton = styled(TextButton)(_templateObject$3());

var GlobalOptions =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(GlobalOptions, _React$PureComponent);

  function GlobalOptions(props) {
    var _this;

    _classCallCheck(this, GlobalOptions);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(GlobalOptions).call(this, props));
    _this.updateOptions = _this.updateOptions.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(GlobalOptions, [{
    key: "updateOptions",
    value: function updateOptions(e) {
      var updateGlobalOptions = this.props.updateGlobalOptions;
      var _e$target = e.target,
          optionId = _e$target.dataset.id,
          value = _e$target.value;
      updateGlobalOptions(optionId, value);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          framesList = _this$props.framesList,
          _this$props$globalOpt = _this$props.globalOptions,
          _this$props$globalOpt2 = _this$props$globalOpt.backgroundColor,
          displayBackgroundColor = _this$props$globalOpt2.display,
          valueBackgroundColor = _this$props$globalOpt2.value,
          displayOptions = _this$props$globalOpt.display,
          _this$props$globalOpt3 = _this$props$globalOpt.fixedFrame,
          displayFixedFrame = _this$props$globalOpt3.display,
          valueFixedFrame = _this$props$globalOpt3.value,
          _this$props$globalOpt4 = _this$props$globalOpt.grid,
          displayGrid = _this$props$globalOpt4.display,
          valueGrid = _this$props$globalOpt4.size,
          toggleConfigurationModal = _this$props.toggleConfigurationModal;

      if (!displayOptions) {
        return null;
      }

      return React.createElement(Container, null, React.createElement(EditConfigButton, {
        onClick: toggleConfigurationModal
      }, "Edit Configuration"), displayBackgroundColor && React.createElement(OptionRow, {
        label: "Background Color"
      }, React.createElement(Input, {
        type: "color",
        "data-id": "backgroundColor.value",
        value: valueBackgroundColor,
        onChange: this.updateOptions
      })), displayGrid && React.createElement(OptionRow, {
        label: "Grid size"
      }, valueGrid), displayFixedFrame && React.createElement(OptionRow, {
        label: "Fixed frame"
      }, React.createElement(Select, {
        value: valueFixedFrame,
        "data-id": "fixedFrame.value",
        onChange: this.updateOptions
      }, _.map(framesList, function (f) {
        return React.createElement("option", {
          key: f,
          value: f
        }, f);
      }))));
    }
  }]);

  return GlobalOptions;
}(React.PureComponent);

var ConnectionDot =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(ConnectionDot, _React$PureComponent);

  function ConnectionDot() {
    _classCallCheck(this, ConnectionDot);

    return _possibleConstructorReturn(this, _getPrototypeOf(ConnectionDot).apply(this, arguments));
  }

  _createClass(ConnectionDot, [{
    key: "render",
    value: function render() {
      var status = this.props.status;
      return React.createElement(RosStatusIndicator, {
        status: status
      });
    }
  }]);

  return ConnectionDot;
}(React.PureComponent);

var MIN_TIMER_TIME = 0;
var MAX_TIMER_TIME = 100;
var TIMER_INCREMENT = 5;
var ONE_SECOND = 1000;

var RosReconnectHandler =
/*#__PURE__*/
function (_React$Component) {
  _inherits(RosReconnectHandler, _React$Component);

  function RosReconnectHandler(props) {
    var _this;

    _classCallCheck(this, RosReconnectHandler);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(RosReconnectHandler).call(this, props));
    _this.state = {
      timer: 0
    };
    _this.retryTime = MIN_TIMER_TIME;
    _this.timerInstance = null;
    _this.onTick = _this.onTick.bind(_assertThisInitialized(_this));
    _this.startTimer = _this.startTimer.bind(_assertThisInitialized(_this));
    _this.stopTimer = _this.stopTimer.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(RosReconnectHandler, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var rosStatus = this.props.rosStatus;

      switch (rosStatus) {
        case ROS_SOCKET_STATUSES.CONNECTED:
          this.retryTime = MIN_TIMER_TIME;
          break;

        case ROS_SOCKET_STATUSES.CONNECTING:
          this.stopTimer();
          break;

        case ROS_SOCKET_STATUSES.CONNECTION_ERROR:
        case ROS_SOCKET_STATUSES.INITIAL:
        default:
          if (!this.timerInstance && this.retryTime < MAX_TIMER_TIME) {
            this.retryTime += TIMER_INCREMENT;
            this.startTimer();
          }

      }
    }
  }, {
    key: "onTick",
    value: function onTick() {
      var timer = this.state.timer;
      var connectRos = this.props.connectRos;

      if (timer === 0) {
        this.timerInstance = null;
        connectRos();
      } else {
        this.setState({
          timer: timer - 1
        });
        this.timerInstance = setTimeout(this.onTick, ONE_SECOND);
      }
    }
  }, {
    key: "startTimer",
    value: function startTimer() {
      this.setState({
        timer: this.retryTime
      });
      this.timerInstance = setTimeout(this.onTick, ONE_SECOND);
    }
  }, {
    key: "stopTimer",
    value: function stopTimer() {
      if (this.timerInstance) {
        clearTimeout(this.timerInstance);
        this.timerInstance = null;
        this.setState({
          timer: 0
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var timer = this.state.timer;
      var rosStatus = this.props.rosStatus;

      if (includes([ROS_SOCKET_STATUSES.CONNECTING, ROS_SOCKET_STATUSES.CONNECTED], rosStatus)) {
        return null;
      }

      return timer > 0 ? "Reconnecting in ".concat(timer, " seconds") : null;
    }
  }]);

  return RosReconnectHandler;
}(React.Component);

var Logo = function Logo() {
  return React.createElement("svg", {
    viewBox: "0 0 1870.38 418.16",
    style: {
      fill: '#000'
    }
  }, React.createElement("polygon", {
    points: "159.8 241.17 231.44 365.27 303.09 241.17 159.8 241.17"
  }), React.createElement("polygon", {
    points: "54.32 58.49 98.6 135.18 364.28 135.18 320 58.49 54.32 58.49"
  }), React.createElement("polygon", {
    points: "480.2 182.67 408.56 58.58 336.91 182.67 480.2 182.67"
  }), React.createElement("polygon", {
    points: "585.68 365.35 541.4 288.66 275.72 288.66 320 365.35 585.68 365.35"
  }), React.createElement("path", {
    d: "M885.76,59.56c6,0,7.57,3.79,5.68,9.08L797.19,312.4h83.27c3.79,0,6.06,1.89,6.06,6.05v37.48c0,3.78-2.27,6.05-6.06,6.43H733.22c-6.05,0-7.94-3.78-5.67-9.08L821.79,109.9H743.44c-3.78,0-6.05-2.27-6.05-6.06V66c0-4.16,2.27-6,6.05-6.43Z"
  }), React.createElement("path", {
    d: "M1065.92,103.46c0,3.79-1.51,6.44-6.05,6.44H965.24v75.7h72.29c3.79,0,6.06,2.27,6.06,6.43v37.48c0,4.16-2.27,6.43-6.06,6.43H965.24V312.4h94.63c4.54,0,6.05,1.89,6.05,6.05v37.86c0,3.78-1.51,6.05-6.05,6.05H920.58c-3.41,0-5.68-2.27-5.68-6.05V65.62c0-3.79,2.27-6.06,5.68-6.06h139.29c4.54,0,6.05,2.27,6.05,6.06Z"
  }), React.createElement("path", {
    d: "M1241.54,59.56c4.17,0,6.06,2.27,6.06,6.06v37.84c0,3.79-1.89,6.06-6.06,6.06h-43.9V356.31c0,4.16-1.89,6.05-6.06,6.05h-39.36c-3.79,0-6.06-1.89-6.06-6.05V109.52h-43.91c-3.78,0-6.06-2.27-6.06-6.06V65.62c0-3.79,2.28-6.06,6.06-6.06Z"
  }), React.createElement("path", {
    d: "M1377.8,65.62c0-3.79,2.27-6.06,6-6.06h39c4.54,0,6.43,2.27,6.43,6.06V356.31c0,3.78-1.89,6.05-6.43,6.05h-39c-3.78,0-6-2.27-6-6.05V235.94h-48.45V356.31c0,3.78-2.27,6.05-6.06,6.05h-39c-4.55,0-6.44-2.27-6.44-6.05V65.62c0-3.79,1.89-6.06,6.44-6.06h39c3.79,0,6.06,2.27,6.06,6.06V186h48.45Z"
  }), React.createElement("path", {
    d: "M1611,59.56a7.59,7.59,0,0,1,7.57,7.57V307.86c0,35.57-18.92,54.5-54.5,54.5h-42.39c-35.58,0-54.51-18.93-54.51-54.5V67.13a7.6,7.6,0,0,1,7.57-7.57H1511a7.6,7.6,0,0,1,7.57,7.57V297.26c0,10.22,5.3,15.14,15.14,15.14h19.68c9.84,0,15.14-4.92,15.14-15.14V67.13a7.6,7.6,0,0,1,7.57-7.57Z"
  }), React.createElement("path", {
    d: "M1753.27,59.56c35.58,0,54.5,18.92,54.5,54.5v40.12c0,3.79-1.89,6.06-6,6.06h-39.37c-3.78,0-6-2.27-6-6.06V124.66c0-9.84-4.92-15.14-15.15-15.14H1723c-9.46,0-15.14,5.3-15.14,15.14v52.23l90.08,29.53c6.44,2.65,9.84,6.81,9.84,14v87.44c0,35.57-18.92,54.5-54.5,54.5h-42.39c-35.2,0-54.51-18.93-54.51-54.5V268.11c0-4.16,2.27-6.05,6.06-6.05h39.36c4.17,0,6.06,1.89,6.06,6.05v29.15c0,10.22,5.68,15.14,15.14,15.14h18.16c9.85,0,15.15-4.92,15.15-15.14V246.92l-89.71-29.53c-6.81-2.27-10.22-6.81-10.22-14V114.06c0-35.58,19.31-54.5,54.51-54.5Z"
  }));
};

var Intensity = function Intensity(props) {
  var _props$options = props.options,
      autocomputeIntensityBounds = _props$options.autocomputeIntensityBounds,
      channelName = _props$options.channelName,
      maxColor = _props$options.maxColor,
      maxIntensity = _props$options.maxIntensity,
      minColor = _props$options.minColor,
      minIntensity = _props$options.minIntensity,
      useRainbow = _props$options.useRainbow,
      updateOptions = props.updateOptions;
  return React.createElement(React.Fragment, null, React.createElement(OptionRow, {
    label: "Channel Name"
  }, React.createElement(Select, {
    name: "channelName",
    "data-id": "channelName",
    onChange: updateOptions,
    value: channelName
  }, _.map(INTENSITY_CHANNEL_OPTIONS, function (channel) {
    return React.createElement("option", {
      key: channel,
      value: channel
    }, channel);
  }))), !useRainbow && React.createElement(React.Fragment, null, React.createElement(OptionRow, {
    label: "Min Color"
  }, React.createElement(Input, {
    name: "minColor",
    type: "color",
    "data-id": "minColor",
    value: minColor,
    onChange: updateOptions
  })), React.createElement(OptionRow, {
    label: "Max Color"
  }, React.createElement(Input, {
    name: "maxColor",
    type: "color",
    "data-id": "maxColor",
    value: maxColor,
    onChange: updateOptions
  }))), !autocomputeIntensityBounds && React.createElement(React.Fragment, null, React.createElement(OptionRow, {
    label: "Min Intensity"
  }, React.createElement(Input, {
    type: "number",
    name: "minIntensity",
    "data-id": "minIntensity",
    value: minIntensity,
    onChange: updateOptions
  })), React.createElement(OptionRow, {
    label: "Max Intensity"
  }, React.createElement(Input, {
    type: "number",
    name: "maxIntensity",
    "data-id": "maxIntensity",
    value: maxIntensity,
    onChange: updateOptions
  }))));
};

var AxisColor = function AxisColor(props) {
  var _props$options2 = props.options,
      autocomputeValueBounds = _props$options2.autocomputeValueBounds,
      axis = _props$options2.axis,
      maxAxisValue = _props$options2.maxAxisValue,
      minAxisValue = _props$options2.minAxisValue,
      updateOptions = props.updateOptions;
  return React.createElement(React.Fragment, null, React.createElement(OptionRow, {
    label: "Axis"
  }, React.createElement(Select, {
    name: "axis",
    "data-id": "axis",
    onChange: updateOptions,
    value: axis
  }, _.map(AXES, function (a) {
    return React.createElement("option", {
      key: a,
      value: a
    }, a);
  }))), !autocomputeValueBounds && React.createElement(OptionContainer, null, React.createElement(OptionRow, {
    label: "Min Value"
  }, React.createElement(Input, {
    type: "number",
    name: "minAxisValue",
    "data-id": "minAxisValue",
    value: minAxisValue,
    onChange: updateOptions
  })), React.createElement(OptionRow, {
    label: "Max Value"
  }, React.createElement(Input, {
    type: "number",
    name: "maxAxisValue",
    "data-id": "maxAxisValue",
    value: maxAxisValue,
    onChange: updateOptions
  }))));
};

var ColorTransformer =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(ColorTransformer, _React$PureComponent);

  function ColorTransformer() {
    _classCallCheck(this, ColorTransformer);

    return _possibleConstructorReturn(this, _getPrototypeOf(ColorTransformer).apply(this, arguments));
  }

  _createClass(ColorTransformer, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          _this$props$options = _this$props.options,
          colorTransformer = _this$props$options.colorTransformer,
          flatColor = _this$props$options.flatColor,
          options = _this$props.options,
          updateOptions = _this$props.updateOptions;

      switch (colorTransformer) {
        case COLOR_TRANSFORMERS.INTENSITY:
          return React.createElement(Intensity, {
            options: options,
            updateOptions: updateOptions
          });

        case COLOR_TRANSFORMERS.AXIS_COLOR:
          return React.createElement(AxisColor, {
            options: options,
            updateOptions: updateOptions
          });

        case COLOR_TRANSFORMERS.FLAT_COLOR:
          return React.createElement(OptionRow, {
            label: "Flat Color"
          }, React.createElement(Input, {
            type: "color",
            name: "flatColor",
            "data-id": "flatColor",
            value: flatColor,
            onChange: updateOptions
          }));

        default:
          return null;
      }
    }
  }]);

  return ColorTransformer;
}(React.PureComponent);

function ownKeys$3(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$3(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$3(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$3(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var LaserScanOptions =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(LaserScanOptions, _React$PureComponent);

  function LaserScanOptions(props) {
    var _this;

    _classCallCheck(this, LaserScanOptions);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(LaserScanOptions).call(this, props));
    _this.updateOptions = updateOptionsUtil.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(LaserScanOptions, [{
    key: "render",
    value: function render() {
      var propsOptions = this.props.options;

      var options = _objectSpread$3({}, DEFAULT_OPTIONS_LASERSCAN, {}, propsOptions);

      var alpha = options.alpha,
          colorTransformer = options.colorTransformer,
          size = options.size,
          style = options.style;
      return React.createElement(React.Fragment, null, React.createElement(OptionRow, {
        label: "Style"
      }, React.createElement(Select, {
        name: "style",
        "data-id": "style",
        onChange: this.updateOptions,
        value: style
      }, _.map(LASERSCAN_STYLES, function (lStyle) {
        return React.createElement("option", {
          key: lStyle,
          value: lStyle
        }, lStyle);
      }))), React.createElement(OptionRow, {
        label: "Size"
      }, React.createElement(Input, {
        type: "number",
        name: "size",
        "data-id": "size",
        value: size,
        onChange: this.updateOptions
      })), React.createElement(OptionRow, {
        label: "Alpha"
      }, React.createElement(Input, {
        type: "number",
        name: "alpha",
        "data-id": "alpha",
        value: alpha,
        onChange: this.updateOptions
      })), React.createElement(OptionRow, {
        label: "Color Transformer"
      }, React.createElement(Select, {
        name: "colorTransformer",
        "data-id": "colorTransformer",
        onChange: this.updateOptions,
        value: colorTransformer
      }, _.map(COLOR_TRANSFORMERS, function (color) {
        return React.createElement("option", {
          key: color,
          value: color
        }, color);
      }))), React.createElement(ColorTransformer, {
        options: options,
        updateOptions: this.updateOptions
      }));
    }
  }]);

  return LaserScanOptions;
}(React.PureComponent);

function ownKeys$4(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$4(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$4(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$4(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var MapOptions =
/*#__PURE__*/
function (_React$Component) {
  _inherits(MapOptions, _React$Component);

  function MapOptions(props) {
    var _this;

    _classCallCheck(this, MapOptions);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(MapOptions).call(this, props));
    _this.updateOptions = updateOptionsUtil.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(MapOptions, [{
    key: "render",
    value: function render() {
      var propsOptions = this.props.options;

      var options = _objectSpread$4({}, DEFAULT_OPTIONS_MAP, {}, propsOptions);

      var alpha = options.alpha,
          colorScheme = options.colorScheme,
          drawBehind = options.drawBehind;
      return React.createElement(React.Fragment, null, React.createElement(OptionRow, {
        label: "Alpha"
      }, React.createElement(Input, {
        type: "number",
        name: "alpha",
        "data-id": "alpha",
        value: alpha,
        onChange: this.updateOptions
      })), React.createElement(OptionRow, {
        label: "Color Scheme"
      }, React.createElement(Select, {
        name: "colorScheme",
        "data-id": "colorScheme",
        onChange: this.updateOptions,
        value: colorScheme
      }, _.map(MAP_COLOR_SCHEMES, function (scheme) {
        return React.createElement("option", {
          key: scheme,
          value: scheme
        }, scheme);
      }))), React.createElement(OptionRow, {
        label: "Draw Behind"
      }, React.createElement(Input, {
        type: "checkbox",
        name: "drawBehind",
        "data-id": "drawBehind",
        value: drawBehind,
        onChange: this.updateOptions
      })));
    }
  }]);

  return MapOptions;
}(React.Component);

function ownKeys$5(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$5(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$5(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$5(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var MarkerOptions =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(MarkerOptions, _React$PureComponent);

  function MarkerOptions(props) {
    var _this;

    _classCallCheck(this, MarkerOptions);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(MarkerOptions).call(this, props));
    _this.updateNamespaceVisibility = _this.updateNamespaceVisibility.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(MarkerOptions, [{
    key: "updateNamespaceVisibility",
    value: function updateNamespaceVisibility(e) {
      var _this$props = this.props,
          _this$props$options = _this$props.options,
          key = _this$props$options.key,
          namespaces = _this$props$options.namespaces,
          updateVizOptions = _this$props.updateVizOptions;
      var _e$target = e.target,
          checked = _e$target.checked,
          optionId = _e$target.dataset.id;
      updateVizOptions(key, {
        namespaces: _objectSpread$5({}, namespaces, _defineProperty({}, optionId, checked))
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var propsOptions = this.props.options;

      var _DEFAULT_OPTIONS_MARK = _objectSpread$5({}, DEFAULT_OPTIONS_MARKER, {}, propsOptions),
          namespaces = _DEFAULT_OPTIONS_MARK.namespaces;

      if (_.size(_.compact(_.keys(namespaces))) === 0) {
        return null;
      }

      return React.createElement(React.Fragment, null, "Namespaces:", React.createElement(OptionContainer, null, _.map(namespaces, function (checked, key) {
        return key ? React.createElement(OptionRow, {
          label: key
        }, React.createElement(Input, {
          name: key,
          type: "checkbox",
          "data-id": "key",
          checked: checked,
          onChange: _this2.updateNamespaceVisibility
        })) : null;
      })));
    }
  }]);

  return MarkerOptions;
}(React.PureComponent);

function ownKeys$6(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$6(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$6(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$6(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var ArrowOptions =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(ArrowOptions, _React$PureComponent);

  function ArrowOptions() {
    _classCallCheck(this, ArrowOptions);

    return _possibleConstructorReturn(this, _getPrototypeOf(ArrowOptions).apply(this, arguments));
  }

  _createClass(ArrowOptions, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          propsOptions = _this$props.options,
          updateOptions = _this$props.updateOptions;

      var _DEFAULT_OPTIONS_ARRO = _objectSpread$6({}, DEFAULT_OPTIONS_ARROW, {}, propsOptions),
          alpha = _DEFAULT_OPTIONS_ARRO.alpha,
          color = _DEFAULT_OPTIONS_ARRO.color,
          headLength = _DEFAULT_OPTIONS_ARRO.headLength,
          headRadius = _DEFAULT_OPTIONS_ARRO.headRadius,
          shaftLength = _DEFAULT_OPTIONS_ARRO.shaftLength,
          shaftRadius = _DEFAULT_OPTIONS_ARRO.shaftRadius;

      return React.createElement(React.Fragment, null, React.createElement(OptionRow, {
        label: "Color"
      }, React.createElement(Input, {
        name: "color",
        type: "color",
        value: color,
        "data-id": "color",
        onChange: updateOptions
      })), React.createElement(OptionRow, {
        label: "Alpha"
      }, React.createElement(Input, {
        name: "alpha",
        type: "number",
        value: alpha,
        "data-id": "alpha",
        onChange: updateOptions
      })), React.createElement(OptionRow, {
        label: "Shaft Length"
      }, React.createElement(Input, {
        name: "shaftLength",
        type: "number",
        value: shaftLength,
        "data-id": "shaftLength",
        onChange: updateOptions
      })), React.createElement(OptionRow, {
        label: "Shaft Radius"
      }, React.createElement(Input, {
        name: "shaftRadius",
        type: "number",
        value: shaftRadius,
        "data-id": "shaftRadius",
        onChange: updateOptions
      })), React.createElement(OptionRow, {
        label: "Head Length"
      }, React.createElement(Input, {
        name: "headLength",
        type: "number",
        value: headLength,
        "data-id": "headLength",
        onChange: updateOptions
      })), React.createElement(OptionRow, {
        label: "Head Radius"
      }, React.createElement(Input, {
        name: "headRadius",
        type: "number",
        value: headRadius,
        "data-id": "headRadius",
        onChange: updateOptions
      })));
    }
  }]);

  return ArrowOptions;
}(React.PureComponent);

function ownKeys$7(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$7(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$7(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$7(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var FlatArrowOptions =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(FlatArrowOptions, _React$PureComponent);

  function FlatArrowOptions() {
    _classCallCheck(this, FlatArrowOptions);

    return _possibleConstructorReturn(this, _getPrototypeOf(FlatArrowOptions).apply(this, arguments));
  }

  _createClass(FlatArrowOptions, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          propsOptions = _this$props.options,
          updateOptions = _this$props.updateOptions;

      var _DEFAULT_OPTIONS_FLAT = _objectSpread$7({}, DEFAULT_OPTIONS_FLATARROW, {}, propsOptions),
          alpha = _DEFAULT_OPTIONS_FLAT.alpha,
          arrowLength = _DEFAULT_OPTIONS_FLAT.arrowLength,
          color = _DEFAULT_OPTIONS_FLAT.color;

      return React.createElement(React.Fragment, null, React.createElement(OptionRow, {
        label: "Color"
      }, React.createElement(Input, {
        name: "color",
        type: "color",
        value: color,
        "data-id": "color",
        onChange: updateOptions
      })), React.createElement(OptionRow, {
        label: "Alpha"
      }, React.createElement(Input, {
        name: "alpha",
        type: "number",
        value: alpha,
        "data-id": "alpha",
        onChange: updateOptions
      })), React.createElement(OptionRow, {
        label: "Arrow length"
      }, React.createElement(Input, {
        name: "arrowLength",
        type: "number",
        "data-id": "arrowLength",
        value: arrowLength,
        onChange: updateOptions
      })));
    }
  }]);

  return FlatArrowOptions;
}(React.PureComponent);

function ownKeys$8(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$8(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$8(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$8(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var AxesOptions =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(AxesOptions, _React$PureComponent);

  function AxesOptions() {
    _classCallCheck(this, AxesOptions);

    return _possibleConstructorReturn(this, _getPrototypeOf(AxesOptions).apply(this, arguments));
  }

  _createClass(AxesOptions, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          propsOptions = _this$props.options,
          updateOptions = _this$props.updateOptions;

      var _DEFAULT_OPTIONS_AXES = _objectSpread$8({}, DEFAULT_OPTIONS_AXES, {}, propsOptions),
          axesLength = _DEFAULT_OPTIONS_AXES.axesLength,
          axesRadius = _DEFAULT_OPTIONS_AXES.axesRadius;

      return React.createElement(React.Fragment, null, React.createElement(OptionRow, {
        label: "Axes Length"
      }, React.createElement(Input, {
        name: "axesLength",
        type: "number",
        "data-id": "axesLength",
        value: axesLength,
        onChange: updateOptions
      })), React.createElement(OptionRow, {
        label: "Axes Radius"
      }, React.createElement(Input, {
        name: "axesRadius",
        type: "number",
        "data-id": "axesRadius",
        value: axesRadius,
        onChange: updateOptions
      })));
    }
  }]);

  return AxesOptions;
}(React.PureComponent);

var ShapeOptions =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(ShapeOptions, _React$PureComponent);

  function ShapeOptions() {
    _classCallCheck(this, ShapeOptions);

    return _possibleConstructorReturn(this, _getPrototypeOf(ShapeOptions).apply(this, arguments));
  }

  _createClass(ShapeOptions, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          options = _this$props.options,
          shapeType = _this$props.options.type,
          updateOptions = _this$props.updateOptions;

      switch (shapeType) {
        case OBJECT_TYPE_ARROW:
          return React.createElement(ArrowOptions, {
            updateOptions: updateOptions,
            options: options
          });

        case OBJECT_TYPE_FLAT_ARROW:
          return React.createElement(FlatArrowOptions, {
            updateOptions: updateOptions,
            options: options
          });

        case OBJECT_TYPE_AXES:
          return React.createElement(AxesOptions, {
            updateOptions: updateOptions,
            options: options
          });

        default:
          return null;
      }
    }
  }]);

  return ShapeOptions;
}(React.PureComponent);

function ownKeys$9(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$9(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$9(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$9(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var OdometryOptions =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(OdometryOptions, _React$PureComponent);

  function OdometryOptions(props) {
    var _this;

    _classCallCheck(this, OdometryOptions);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(OdometryOptions).call(this, props));
    _this.updateOptions = updateOptionsUtil.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(OdometryOptions, [{
    key: "render",
    value: function render() {
      var propsOptions = this.props.options;

      var options = _objectSpread$9({}, DEFAULT_OPTIONS_ODOMETRY, {}, propsOptions);

      var angleTolerance = options.angleTolerance,
          keep = options.keep,
          positionTolerance = options.positionTolerance,
          shapeType = options.type;
      return React.createElement(React.Fragment, null, React.createElement(OptionRow, {
        label: "Position Tolerance"
      }, React.createElement(Input, {
        name: "positionTolerance",
        type: "number",
        value: positionTolerance,
        "data-id": "positionTolerance",
        onChange: this.updateOptions
      })), React.createElement(OptionRow, {
        label: "Angle Tolerance"
      }, React.createElement(Input, {
        name: "angleTolerance",
        type: "number",
        "data-id": "angleTolerance",
        value: angleTolerance,
        onChange: this.updateOptions
      })), React.createElement(OptionRow, {
        label: "Keep"
      }, React.createElement(Input, {
        name: "keep",
        type: "number",
        "data-id": "keep",
        value: keep,
        onChange: this.updateOptions
      })), React.createElement(OptionRow, {
        label: "Shape"
      }, React.createElement(Select, {
        name: "type",
        "data-id": "type",
        onChange: this.updateOptions,
        value: shapeType
      }, _.map([OBJECT_TYPE_ARROW, OBJECT_TYPE_AXES], function (type) {
        return React.createElement("option", {
          key: type,
          value: type
        }, type);
      }))), React.createElement(OptionContainer, null, React.createElement(ShapeOptions, {
        options: options,
        updateOptions: this.updateOptions
      })));
    }
  }]);

  return OdometryOptions;
}(React.PureComponent);

function ownKeys$a(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$a(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$a(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$a(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var PathOptions =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(PathOptions, _React$PureComponent);

  function PathOptions(props) {
    var _this;

    _classCallCheck(this, PathOptions);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PathOptions).call(this, props));
    _this.updateOptions = updateOptionsUtil.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(PathOptions, [{
    key: "render",
    value: function render() {
      var propsOptions = this.props.options;

      var _DEFAULT_OPTIONS_PATH = _objectSpread$a({}, DEFAULT_OPTIONS_PATH, {}, propsOptions),
          alpha = _DEFAULT_OPTIONS_PATH.alpha,
          color = _DEFAULT_OPTIONS_PATH.color;

      return React.createElement(React.Fragment, null, React.createElement(OptionRow, {
        label: "Color"
      }, React.createElement(Input, {
        type: "color",
        name: "color",
        "data-id": "color",
        value: color,
        onChange: this.updateOptions
      })), React.createElement(OptionRow, {
        label: "Alpha"
      }, React.createElement(Input, {
        type: "number",
        name: "alpha",
        "data-id": "alpha",
        value: alpha,
        onChange: this.updateOptions
      })));
    }
  }]);

  return PathOptions;
}(React.PureComponent);

var _dropdownOptions;

function ownKeys$b(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$b(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$b(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$b(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var dropdownOptions = (_dropdownOptions = {}, _defineProperty(_dropdownOptions, VIZ_TYPE_POSE, [OBJECT_TYPE_ARROW, OBJECT_TYPE_AXES]), _defineProperty(_dropdownOptions, VIZ_TYPE_POSEARRAY, [OBJECT_TYPE_ARROW, OBJECT_TYPE_AXES, OBJECT_TYPE_FLAT_ARROW]), _dropdownOptions);

var PoseOptions =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(PoseOptions, _React$PureComponent);

  function PoseOptions(props) {
    var _this;

    _classCallCheck(this, PoseOptions);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PoseOptions).call(this, props));
    _this.updateOptions = updateOptionsUtil.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(PoseOptions, [{
    key: "render",
    value: function render() {
      var propsOptions = this.props.options;

      var options = _objectSpread$b({}, DEFAULT_OPTIONS_POSE, {}, propsOptions);

      var shapeType = options.type,
          vizType = options.vizType;
      return React.createElement(React.Fragment, null, React.createElement(OptionRow, {
        label: "Shape"
      }, React.createElement(Select, {
        name: "type",
        "data-id": "type",
        onChange: this.updateOptions,
        value: shapeType
      }, _.map(dropdownOptions[vizType], function (o) {
        return React.createElement("option", {
          key: o,
          value: o
        }, o);
      }))), React.createElement(OptionContainer, null, React.createElement(ShapeOptions, {
        options: options,
        updateOptions: this.updateOptions
      })));
    }
  }]);

  return PoseOptions;
}(React.PureComponent);

function ownKeys$c(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$c(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$c(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$c(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var PointCloudOptions =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(PointCloudOptions, _React$PureComponent);

  function PointCloudOptions(props) {
    var _this;

    _classCallCheck(this, PointCloudOptions);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PointCloudOptions).call(this, props));
    _this.updateOptions = updateOptionsUtil.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(PointCloudOptions, [{
    key: "render",
    value: function render() {
      var propsOptions = this.props.options;

      var options = _objectSpread$c({}, DEFAULT_OPTIONS_POINTCLOUD, {}, propsOptions);

      var colorChannel = options.colorChannel,
          size = options.size,
          useRainbow = options.useRainbow;
      return React.createElement(React.Fragment, null, React.createElement(OptionRow, {
        label: "Color channel"
      }, React.createElement(Select, {
        name: "colorChannel",
        "data-id": "colorChannel",
        onChange: this.updateOptions,
        value: colorChannel
      }, _.map(POINTCLOUD_COLOR_CHANNELS, function (lStyle) {
        return React.createElement("option", {
          key: lStyle,
          value: lStyle
        }, lStyle);
      }))), React.createElement(OptionRow, {
        label: "Size"
      }, React.createElement(Input, {
        type: "number",
        name: "size",
        "data-id": "size",
        value: size,
        onChange: this.updateOptions
      })), colorChannel === POINTCLOUD_COLOR_CHANNELS.INTENSITY && React.createElement(OptionRow, {
        label: "Use Rainbow"
      }, React.createElement(Input, {
        type: "checkbox",
        name: "useRainbow",
        "data-id": "useRainbow",
        value: useRainbow,
        onChange: this.updateOptions
      })));
    }
  }]);

  return PointCloudOptions;
}(React.PureComponent);

function ownKeys$d(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$d(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$d(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$d(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var RangeOptions =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(RangeOptions, _React$PureComponent);

  function RangeOptions(props) {
    var _this;

    _classCallCheck(this, RangeOptions);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(RangeOptions).call(this, props));
    _this.updateOptions = updateOptionsUtil.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(RangeOptions, [{
    key: "render",
    value: function render() {
      var propsOptions = this.props.options;

      var _DEFAULT_OPTIONS_RANG = _objectSpread$d({}, DEFAULT_OPTIONS_RANGE, {}, propsOptions),
          alpha = _DEFAULT_OPTIONS_RANG.alpha,
          color = _DEFAULT_OPTIONS_RANG.color;

      return React.createElement(React.Fragment, null, React.createElement(OptionRow, {
        label: "Color"
      }, React.createElement(Input, {
        type: "color",
        name: "color",
        "data-id": "color",
        value: color,
        onChange: this.updateOptions
      })), React.createElement(OptionRow, {
        label: "Alpha"
      }, React.createElement(Input, {
        type: "number",
        name: "alpha",
        "data-id": "alpha",
        value: alpha,
        onChange: this.updateOptions
      })));
    }
  }]);

  return RangeOptions;
}(React.PureComponent);

function ownKeys$e(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$e(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$e(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$e(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var PointOptions =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(PointOptions, _React$PureComponent);

  function PointOptions(props) {
    var _this;

    _classCallCheck(this, PointOptions);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PointOptions).call(this, props));
    _this.updateOptions = updateOptionsUtil.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(PointOptions, [{
    key: "render",
    value: function render() {
      var propsOptions = this.props.options;

      var _DEFAULT_OPTIONS_POIN = _objectSpread$e({}, DEFAULT_OPTIONS_POINT, {}, propsOptions),
          alpha = _DEFAULT_OPTIONS_POIN.alpha,
          color = _DEFAULT_OPTIONS_POIN.color,
          radius = _DEFAULT_OPTIONS_POIN.radius;

      return React.createElement(React.Fragment, null, React.createElement(OptionRow, {
        label: "Radius"
      }, React.createElement(Input, {
        type: "number",
        name: "radius",
        step: "0.01",
        "data-id": "radius",
        value: radius,
        onChange: this.updateOptions
      })), React.createElement(OptionRow, {
        label: "Color"
      }, React.createElement(Input, {
        type: "color",
        name: "color",
        "data-id": "color",
        value: color,
        onChange: this.updateOptions
      })), React.createElement(OptionRow, {
        label: "Alpha"
      }, React.createElement(Input, {
        type: "number",
        name: "alpha",
        step: "0.01",
        "data-id": "alpha",
        value: alpha,
        onChange: this.updateOptions
      })));
    }
  }]);

  return PointOptions;
}(React.PureComponent);

var InteractiveMarkerOptions =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(InteractiveMarkerOptions, _React$PureComponent);

  function InteractiveMarkerOptions(props) {
    var _this;

    _classCallCheck(this, InteractiveMarkerOptions);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(InteractiveMarkerOptions).call(this, props));
    var _this$props = _this.props,
        propsOptions = _this$props.options,
        relatedTopics = _this$props.relatedTopics,
        updateVizOptions = _this$props.updateVizOptions;
    var key = propsOptions.key;
    _this.updateTopics = _.filter(relatedTopics, function (t) {
      return t.messageType === MESSAGE_TYPE_INTERACTIVEMARKER_UPDATE;
    });
    _this.feedbackTopics = _.filter(relatedTopics, function (t) {
      return t.messageType === MESSAGE_TYPE_INTERACTIVEMARKER_FEEDBACK;
    });
    updateVizOptions(key, {
      updateTopicName: {
        name: _this.updateTopics.length > 0 ? _this.updateTopics[0].name : '',
        messageType: MESSAGE_TYPE_INTERACTIVEMARKER_UPDATE
      },
      feedbackTopicName: {
        name: _this.feedbackTopics.length > 0 ? _this.feedbackTopics[0].name : '',
        messageType: MESSAGE_TYPE_INTERACTIVEMARKER_FEEDBACK
      }
    });
    return _this;
  }

  _createClass(InteractiveMarkerOptions, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          propsOptions = _this$props2.options,
          updateVizOptions = _this$props2.updateVizOptions;
      var feedbackTopicName = propsOptions.feedbackTopicName,
          key = propsOptions.key,
          updateTopicName = propsOptions.updateTopicName;
      return React.createElement(React.Fragment, null, React.createElement(OptionRow, {
        label: "Update Topic"
      }, React.createElement(Select, {
        value: updateTopicName || '',
        onChange: function onChange(e) {
          return updateVizOptions(key, {
            updateTopicName: {
              name: e.target.value,
              messageType: MESSAGE_TYPE_INTERACTIVEMARKER_UPDATE
            }
          });
        }
      }, React.createElement("option", {
        value: "",
        disabled: true,
        hidden: true
      }, "Select"), _.map(this.updateTopics, function (topic) {
        return React.createElement("option", {
          key: topic.name
        }, topic.name);
      }))), React.createElement(OptionRow, {
        label: "Feedback Topic"
      }, React.createElement(Select, {
        value: feedbackTopicName || '',
        onChange: function onChange(e) {
          return updateVizOptions(key, {
            feedbackTopicName: {
              name: e.target.value,
              messageType: MESSAGE_TYPE_INTERACTIVEMARKER_FEEDBACK
            }
          });
        }
      }, React.createElement("option", {
        value: "",
        disabled: true,
        hidden: true
      }, "Select"), _.map(this.feedbackTopics, function (topic) {
        return React.createElement("option", {
          key: topic.name
        }, topic.name);
      }))));
    }
  }]);

  return InteractiveMarkerOptions;
}(React.PureComponent);

function ownKeys$f(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$f(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$f(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$f(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var WrenchOptions =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(WrenchOptions, _React$PureComponent);

  function WrenchOptions(props) {
    var _this;

    _classCallCheck(this, WrenchOptions);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(WrenchOptions).call(this, props));
    _this.updateOptions = updateOptionsUtil.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(WrenchOptions, [{
    key: "render",
    value: function render() {
      var propsOptions = this.props.options;

      var _DEFAULT_OPTIONS_WREN = _objectSpread$f({}, DEFAULT_OPTIONS_WRENCH, {}, propsOptions),
          alpha = _DEFAULT_OPTIONS_WREN.alpha,
          arrowWidth = _DEFAULT_OPTIONS_WREN.arrowWidth,
          forceArrowScale = _DEFAULT_OPTIONS_WREN.forceArrowScale,
          forceColor = _DEFAULT_OPTIONS_WREN.forceColor,
          torqueArrowScale = _DEFAULT_OPTIONS_WREN.torqueArrowScale,
          torqueColor = _DEFAULT_OPTIONS_WREN.torqueColor;

      return React.createElement(React.Fragment, null, React.createElement(OptionRow, {
        label: "forceColor"
      }, React.createElement(Input, {
        type: "color",
        name: "forceColor",
        "data-id": "forceColor",
        value: forceColor,
        onChange: this.updateOptions
      })), React.createElement(OptionRow, {
        label: "torqueColor"
      }, React.createElement(Input, {
        type: "color",
        name: "torqueColor",
        "data-id": "torqueColor",
        value: torqueColor,
        onChange: this.updateOptions
      })), React.createElement(OptionRow, {
        label: "alpha"
      }, React.createElement(Input, {
        type: "number",
        name: "alpha",
        step: "0.1",
        "data-id": "alpha",
        value: alpha,
        onChange: this.updateOptions
      })), React.createElement(OptionRow, {
        label: "forceArrowScale"
      }, React.createElement(Input, {
        type: "number",
        name: "forceArrowScale",
        step: "0.1",
        "data-id": "forceArrowScale",
        value: forceArrowScale,
        onChange: this.updateOptions
      })), React.createElement(OptionRow, {
        label: "torqueArrowScale"
      }, React.createElement(Input, {
        type: "number",
        name: "torqueArrowScale",
        step: "0.1",
        "data-id": "torqueArrowScale",
        value: torqueArrowScale,
        onChange: this.updateOptions
      })), React.createElement(OptionRow, {
        label: "arrowWidth"
      }, React.createElement(Input, {
        type: "number",
        name: "arrowWidth",
        step: "0.1",
        "data-id": "arrowWidth",
        value: arrowWidth,
        onChange: this.updateOptions
      })));
    }
  }]);

  return WrenchOptions;
}(React.PureComponent);

var VizSpecificOptions = function VizSpecificOptions(_ref) {
  var vizType = _ref.options.vizType,
      options = _ref.options,
      topics = _ref.topics,
      relatedTopics = _ref.relatedTopics,
      updateVizOptions = _ref.updateVizOptions;

  switch (vizType) {
    case VIZ_TYPE_IMAGE:
      return null;

    case VIZ_TYPE_INTERACTIVEMARKER:
      return React.createElement(InteractiveMarkerOptions, {
        options: options,
        topics: topics,
        relatedTopics: relatedTopics,
        updateVizOptions: updateVizOptions
      });

    case VIZ_TYPE_LASERSCAN:
      return React.createElement(LaserScanOptions, {
        options: options,
        updateVizOptions: updateVizOptions
      });

    case VIZ_TYPE_MAP:
      return React.createElement(MapOptions, {
        options: options,
        updateVizOptions: updateVizOptions
      });

    case VIZ_TYPE_MARKER:
      return React.createElement(MarkerOptions, {
        options: options,
        updateVizOptions: updateVizOptions
      });

    case VIZ_TYPE_MARKERARRAY:
      return null;

    case VIZ_TYPE_ODOMETRY:
      return React.createElement(OdometryOptions, {
        options: options,
        updateVizOptions: updateVizOptions
      });

    case VIZ_TYPE_PATH:
      return React.createElement(PathOptions, {
        options: options,
        updateVizOptions: updateVizOptions
      });

    case VIZ_TYPE_POINT:
      return React.createElement(PointOptions, {
        options: options,
        updateVizOptions: updateVizOptions
      });

    case VIZ_TYPE_POINTCLOUD:
      return React.createElement(PointCloudOptions, {
        options: options,
        updateVizOptions: updateVizOptions
      });

    case VIZ_TYPE_POLYGON:
      return null;

    case VIZ_TYPE_POSE:
      return React.createElement(PoseOptions, {
        options: options,
        updateVizOptions: updateVizOptions
      });

    case VIZ_TYPE_POSEARRAY:
      return null;

    case VIZ_TYPE_RANGE:
      return React.createElement(RangeOptions, {
        options: options,
        updateVizOptions: updateVizOptions
      });

    case VIZ_TYPE_ROBOTMODEL:
      return null;

    case VIZ_TYPE_TF:
      return null;

    case VIZ_TYPE_WRENCH:
      return React.createElement(WrenchOptions, {
        options: options,
        updateVizOptions: updateVizOptions
      });

    default:
      return null;
  }
};

var Chevron = function Chevron() {
  return React.createElement("svg", {
    version: "1.1",
    id: "chevron",
    xmlns: "http://www.w3.org/2000/svg",
    x: "0px",
    y: "0px",
    viewBox: "0 0 12.5 6.2",
    style: {
      enableBackground: 'new 0 0 12.5 6.2'
    }
  }, React.createElement("polygon", {
    style: {
      fill: '#888888'
    },
    points: "0.8,0.5 11.6,0.5 6.2,5.9 "
  }));
};

var VizOptions = function VizOptions(_ref) {
  var _ref$options = _ref.options,
      display = _ref$options.display,
      key = _ref$options.key,
      name = _ref$options.name,
      topicName = _ref$options.topicName,
      visible = _ref$options.visible,
      vizType = _ref$options.vizType,
      options = _ref.options,
      topics = _ref.topics,
      relatedTopics = _ref.relatedTopics,
      icon = _ref.vizObject.icon,
      updateVizOptions = _ref.updateVizOptions,
      removeVisualization = _ref.removeVisualization,
      toggleVisibility = _ref.toggleVisibility;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      collapsed = _useState2[0],
      toggleCollapsed = _useState2[1];

  if (_.isBoolean(display) && !display) {
    return null;
  }

  var updateVizOptionsWrapper = function updateVizOptionsWrapper(e) {
    if (vizType === VIZ_TYPE_INTERACTIVEMARKER) {
      updateVizOptions(key, {
        topicName: e.target.value,
        updateTopicName: undefined,
        feedbackTopicName: undefined
      });
      return;
    }

    updateVizOptions(key, {
      topicName: e.target.value
    });
  };

  return React.createElement(VizItem, null, React.createElement(StyledOptionRow, null, React.createElement(VizItemCollapse, {
    collapsed: collapsed,
    onClick: function onClick() {
      return toggleCollapsed(!collapsed);
    }
  }, React.createElement(Chevron, null)), React.createElement(VizItemIcon, null, icon), name), !collapsed && React.createElement(VizItemContent, null, !_.includes([VIZ_TYPE_ROBOTMODEL, VIZ_TYPE_TF], vizType) && React.createElement(OptionRow, {
    label: "Topic"
  }, React.createElement(Select, {
    value: topicName,
    onChange: updateVizOptionsWrapper
  }, _.map(topics, function (topic) {
    return React.createElement("option", {
      key: topic.name
    }, topic.name);
  }))), React.createElement(VizSpecificOptions, {
    options: options,
    topics: topics,
    relatedTopics: relatedTopics,
    updateVizOptions: updateVizOptions
  }), React.createElement(VizItemActions, null, React.createElement(Button, {
    "data-id": key,
    onClick: removeVisualization
  }, "Delete"), React.createElement(Button, {
    "data-id": key,
    onClick: toggleVisibility
  }, _.isBoolean(visible) && !visible ? 'Show' : 'Hide'))));
};

var Sidebar =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Sidebar, _React$Component);

  function Sidebar(props) {
    var _this;

    _classCallCheck(this, Sidebar);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Sidebar).call(this, props));
    _this.state = {
      rosInput: props.rosEndpoint
    };
    _this.updateRosInput = _this.updateRosInput.bind(_assertThisInitialized(_this));
    _this.onSubmit = _this.onSubmit.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Sidebar, [{
    key: "updateRosInput",
    value: function updateRosInput(e) {
      this.setState({
        rosInput: e.target.value
      });
    }
  }, {
    key: "onSubmit",
    value: function onSubmit(e) {
      var _this$props = this.props,
          connectRos = _this$props.connectRos,
          disconnectRos = _this$props.disconnectRos,
          rosEndpoint = _this$props.rosEndpoint,
          rosStatus = _this$props.rosStatus,
          updateRosEndpoint = _this$props.updateRosEndpoint;
      var rosInput = this.state.rosInput;
      e.preventDefault();

      if (rosInput !== rosEndpoint) {
        updateRosEndpoint(rosInput);
      } else if (_.includes([ROS_SOCKET_STATUSES.CONNECTED, ROS_SOCKET_STATUSES.CONNECTING], rosStatus)) {
        disconnectRos();
      } else {
        connectRos();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          connectRos = _this$props2.connectRos,
          visualizations = _this$props2.visualizations,
          globalOptions = _this$props2.globalOptions,
          removeVisualization = _this$props2.removeVisualization,
          rosInstance = _this$props2.rosInstance,
          rosStatus = _this$props2.rosStatus,
          rosTopics = _this$props2.rosTopics,
          framesList = _this$props2.framesList,
          toggleConfigurationModal = _this$props2.toggleConfigurationModal,
          toggleVisibility = _this$props2.toggleVisibility,
          updateGlobalOptions = _this$props2.updateGlobalOptions,
          updateVizOptions = _this$props2.updateVizOptions,
          viewer = _this$props2.viewer,
          toggleAddModal = _this$props2.toggleAddModal;
      var rosInput = this.state.rosInput;
      return React.createElement(StyledSidebar, null, React.createElement(StyledLogo, null, React.createElement(Logo, null)), React.createElement(Separator, null), React.createElement(Container, null, React.createElement(RosStatus, null, React.createElement(ConnectionDot, {
        status: rosStatus
      }), React.createElement("span", null, rosStatus, ".", ' ', React.createElement(RosReconnectHandler, {
        connectRos: connectRos,
        rosStatus: rosStatus
      }))), React.createElement("form", {
        onSubmit: this.onSubmit
      }, React.createElement(InputLabel, null, "ROS Endpoint"), React.createElement(Flex, null, React.createElement(Input, {
        type: "text",
        value: rosInput,
        onChange: this.updateRosInput
      }), React.createElement(FlexSpace, null), React.createElement(ButtonPrimary, {
        type: "submit"
      }, _.includes([ROS_SOCKET_STATUSES.CONNECTED, ROS_SOCKET_STATUSES.CONNECTING], rosStatus) ? 'Disconnect' : 'Connect')))), React.createElement(Separator, null), rosStatus === ROS_SOCKET_STATUSES.CONNECTED && React.createElement(React.Fragment, null, React.createElement(GlobalOptions, {
        framesList: framesList,
        globalOptions: globalOptions,
        updateGlobalOptions: updateGlobalOptions,
        toggleConfigurationModal: toggleConfigurationModal
      }), React.createElement(Separator, null), React.createElement(SidebarVizContainer, null, React.createElement(ButtonPrimary, {
        type: "button",
        onClick: toggleAddModal
      }, "Add Visualization"), _.size(visualizations) === 0 && React.createElement("p", null, "No visualizations added to the scene"), _.map(visualizations, function (vizItem) {
        var vizObject = _.find(vizOptions, function (v) {
          return v.type === vizItem.vizType;
        });

        if (!vizObject) {
          return null;
        }

        var topics = _.filter(rosTopics, function (t) {
          return _.includes(vizObject.messageTypes, t.messageType);
        });

        var relatedTopics = _.filter(rosTopics, function (t) {
          return _.includes(vizObject.additionalMessageTypes, t.messageType);
        });

        return React.createElement(VizOptions, {
          options: vizItem,
          key: vizItem.key,
          viewer: viewer,
          topics: topics,
          relatedTopics: relatedTopics,
          vizObject: vizObject,
          rosInstance: rosInstance,
          updateVizOptions: updateVizOptions,
          removeVisualization: removeVisualization,
          toggleVisibility: toggleVisibility
        });
      }))));
    }
  }]);

  return Sidebar;
}(React.Component);

function _templateObject$4() {
  var data = _taggedTemplateLiteral(["\n  width: 100%;\n  flex-grow: 1;\n  height: 100%;\n  position: relative;\n\n  #viewportStats {\n    position: absolute !important;\n    top: auto !important;\n    left: auto !important;\n    right: 0 !important;\n    bottom: 0 !important;\n  }\n"]);

  _templateObject$4 = function _templateObject() {
    return data;
  };

  return data;
}
var StyledViewport = styled.div(_templateObject$4());

var Viewport =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Viewport, _React$PureComponent);

  function Viewport(props) {
    var _this;

    _classCallCheck(this, Viewport);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Viewport).call(this, props));
    _this.container = React.createRef();
    _this.updateViewerOptions = _this.updateViewerOptions.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Viewport, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.updateViewerOptions();
    }
  }, {
    key: "updateViewerOptions",
    value: function updateViewerOptions() {
      var _this$props = this.props,
          _this$props$globalOpt = _this$props.globalOptions,
          backgroundColor = _this$props$globalOpt.backgroundColor.value,
          selectedFrame = _this$props$globalOpt.fixedFrame.value,
          _this$props$globalOpt2 = _this$props$globalOpt.grid,
          gridCenterlineColor = _this$props$globalOpt2.centerlineColor,
          gridColor = _this$props$globalOpt2.color,
          gridDivisions = _this$props$globalOpt2.divisions,
          gridSize = _this$props$globalOpt2.size,
          viewer = _this$props.viewer;
      viewer.updateOptions({
        backgroundColor: backgroundColor,
        gridSize: gridSize,
        gridDivisions: gridDivisions,
        gridColor: gridColor,
        gridCenterlineColor: gridCenterlineColor,
        selectedFrame: selectedFrame
      });
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var viewer = this.props.viewer;
      var container = this.container.current;
      viewer.setContainer(container);
      this.updateViewerOptions();
      viewer.scene.stats.dom.id = 'viewportStats';
      container.appendChild(viewer.scene.stats.dom);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var viewer = this.props.viewer;
      viewer.destroy();
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement(StyledViewport, {
        ref: this.container
      });
    }
  }]);

  return Viewport;
}(React.PureComponent);

var Visualization =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Visualization, _React$PureComponent);

  function Visualization(props) {
    var _this;

    _classCallCheck(this, Visualization);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Visualization).call(this, props));
    _this.vizInstance = null;
    _this.imageDomRef = React.createRef();
    _this.resetVisualization = _this.resetVisualization.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Visualization, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.resetVisualization();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this$props = this.props,
          _this$props$options = _this$props.options,
          topicName = _this$props$options.topicName,
          visible = _this$props$options.visible,
          vizType = _this$props$options.vizType,
          options = _this$props.options,
          rosTopics = _this$props.rosTopics;

      if (vizType !== prevProps.options.vizType) {
        this.resetVisualization();
      }

      if (vizType === VIZ_TYPE_TF) {
        var currentTfTopics = getTfTopics(rosTopics);
        var prevTfTopics = getTfTopics(prevProps.rosTopics);

        if (_.join(_.sortBy(_.map(currentTfTopics, 'name'))) !== _.join(_.sortBy(_.map(prevTfTopics, 'name')))) {
          this.vizInstance.changeTopic(currentTfTopics);
        }
      } else if (topicName !== prevProps.options.topicName && this.vizInstance.changeTopic) {
        this.vizInstance.changeTopic(topicName);
      }

      if (this.vizInstance) {
        this.vizInstance.updateOptions(options);
      }

      if (visible !== prevProps.options.visible) {
        this.updateVisibility(visible);
      }
    }
  }, {
    key: "resetVisualization",
    value: function resetVisualization() {
      var _this$props2 = this.props,
          options = _this$props2.options,
          _this$props2$options = _this$props2.options,
          topicName = _this$props2$options.topicName,
          visible = _this$props2$options.visible,
          vizType = _this$props2$options.vizType,
          rosInstance = _this$props2.rosInstance,
          rosTopics = _this$props2.rosTopics,
          viewer = _this$props2.viewer;

      if (this.vizInstance) {
        this.vizInstance.destroy();
      }

      this.vizInstance = Visualization.getNewViz(vizType, rosInstance, vizType === VIZ_TYPE_TF ? getTfTopics(rosTopics) : topicName, viewer, options);

      if (!this.vizInstance) {
        return;
      }

      if (vizType === VIZ_TYPE_ROBOTMODEL) {
        viewer.addRobot(this.vizInstance);
      } else if (vizType === VIZ_TYPE_IMAGE) {
        this.imageDomRef.current.appendChild(this.vizInstance.object);
        this.vizInstance.subscribe();
      } else {
        viewer.addVisualization(this.vizInstance);
        this.vizInstance.subscribe();
      }

      this.updateVisibility(!_.isBoolean(visible) || visible);
    }
  }, {
    key: "updateVisibility",
    value: function updateVisibility(visible) {
      if (visible) {
        this.vizInstance.show();
      } else {
        this.vizInstance.hide();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.vizInstance) {
        this.vizInstance.destroy();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props$options2 = this.props.options,
          topicName = _this$props$options2.topicName,
          visible = _this$props$options2.visible,
          vizType = _this$props$options2.vizType;

      if (vizType === VIZ_TYPE_IMAGE) {
        return React.createElement(Rnd, {
          style: {
            visibility: visible ? 'visible' : 'hidden'
          },
          default: {
            x: window.innerWidth - 320 - 30,
            // imageDefaultWidth: 320, imageRight: 30
            y: 30,
            // imageTop: 30
            width: 320,
            height: 265 // imageDefaultHeight: 240 + 25px header padding,

          },
          bounds: "window",
          onResizeStop: function onResizeStop(e, direction, ref) {
            _this2.vizInstance.updateDimensions(Number.parseInt(ref.style.width, 10), Number.parseInt(ref.style.height, 10) - 25 // -25px for header padding
            );
          }
        }, React.createElement(VizImageContainer, {
          ref: this.imageDomRef
        }, React.createElement(VizImageHeader, null, "Image - ", topicName)));
      }

      return null;
    }
  }], [{
    key: "getNewViz",
    value: function getNewViz(vizType, ros, topicName, viewer, options) {
      switch (vizType) {
        case VIZ_TYPE_INTERACTIVEMARKER:
          return new Amphion.InteractiveMarkers(ros, topicName, viewer, options);

        case VIZ_TYPE_IMAGE:
          return new Amphion.Image(ros, topicName, options);

        case VIZ_TYPE_LASERSCAN:
          return new Amphion.LaserScan(ros, topicName, options);

        case VIZ_TYPE_MAP:
          return new Amphion.Map(ros, topicName, options);

        case VIZ_TYPE_MARKER:
          return new Amphion.Marker(ros, topicName, options);

        case VIZ_TYPE_MARKERARRAY:
          return new Amphion.MarkerArray(ros, topicName, options);

        case VIZ_TYPE_ODOMETRY:
          return new Amphion.Odometry(ros, topicName, options);

        case VIZ_TYPE_PATH:
          return new Amphion.Path(ros, topicName, options);

        case VIZ_TYPE_POINT:
          return new Amphion.Point(ros, topicName, options);

        case VIZ_TYPE_POINTCLOUD:
          return new Amphion.PointCloud(ros, topicName, options);

        case VIZ_TYPE_POSE:
          return new Amphion.Pose(ros, topicName, options);

        case VIZ_TYPE_POSEARRAY:
          return new Amphion.PoseArray(ros, topicName, options);

        case VIZ_TYPE_RANGE:
          return new Amphion.Range(ros, topicName, options);

        case VIZ_TYPE_ROBOTMODEL:
          return new Amphion.RobotModel(ros, topicName, options);

        case VIZ_TYPE_TF:
          return new Amphion.Tf(ros, topicName, options);

        case VIZ_TYPE_WRENCH:
          return new Amphion.Wrench(ros, topicName, options);

        default:
          return null;
      }
    }
  }]);

  return Visualization;
}(React.PureComponent);

function _templateObject$5() {
  var data = _taggedTemplateLiteral(["\n  flex-grow: 1;\n  flex-shrink: 1;\n  background-color: ", ";\n  .jsoneditor-menu {\n    background-color: ", ";\n    border-bottom: 0;\n    border-radius: 4px 4px 0 0;\n    & > button {\n      color: ", ";\n    }\n  }\n  .jsoneditor {\n    border: 1px solid ", ";\n    border-radius: 4px;\n  }\n  .ace_editor {\n    font-family: 'Source Code Pro', sans-serif;\n  }\n  .jsoneditor-text {\n    background-color: ", ";\n  }\n  .jsoneditor-statusbar {\n    border-radius: 0 0 4px 4px;\n  }\n"]);

  _templateObject$5 = function _templateObject() {
    return data;
  };

  return data;
}
var StyledEditor = styled.div(_templateObject$5(), COLOR_GREY_LIGHT_1, COLOR_GREY_LIGHT_2, COLOR_PRIMARY, COLOR_GREY_LIGHT_2, COLOR_GREY_LIGHT_1);

var ConfigurationModal =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ConfigurationModal, _React$Component);

  function ConfigurationModal(props) {
    var _this;

    _classCallCheck(this, ConfigurationModal);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ConfigurationModal).call(this, props));
    _this.state = {
      config: props.configuration
    };
    _this.handleChange = _this.handleChange.bind(_assertThisInitialized(_this));
    _this.handleSubmit = _this.handleSubmit.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(ConfigurationModal, [{
    key: "handleChange",
    value: function handleChange(config) {
      this.setState({
        config: config
      });
    }
  }, {
    key: "handleSubmit",
    value: function handleSubmit() {
      var updateConfiguration = this.props.updateConfiguration;
      var config = this.state.config;
      updateConfiguration(config);
    }
  }, {
    key: "render",
    value: function render() {
      var closeModal = this.props.closeModal;
      var config = this.state.config;
      return React.createElement(ModalWrapper, {
        onClick: closeModal
      }, React.createElement(ModalContents, {
        onClick: stopPropagation
      }, React.createElement(ModalTitle, null, "Edit Configuration"), React.createElement(JsonEditor, {
        ace: ace,
        mode: "code",
        value: config,
        onChange: this.handleChange,
        tag: StyledEditor,
        theme: "ace/theme/xcode"
      }), React.createElement(ModalActions, null, React.createElement(FlexGrow, null), React.createElement(ButtonPrimary, {
        onClick: this.handleSubmit
      }, "Update Configuration"), React.createElement(ButtonPrimary, {
        onClick: closeModal
      }, "Cancel"))));
    }
  }]);

  return ConfigurationModal;
}(React.Component);

var Wrapper =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Wrapper, _React$Component);

  function Wrapper(props) {
    var _this;

    _classCallCheck(this, Wrapper);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Wrapper).call(this, props));
    _this.state = {
      rosEndpoint: '',
      rosStatus: ROS_SOCKET_STATUSES.INITIAL,
      addModalOpen: false,
      configurationModalOpen: false,
      rosTopics: [],
      rosParams: [],
      framesList: []
    };
    _this.connectRos = _this.connectRos.bind(_assertThisInitialized(_this));
    _this.disconnectRos = _this.disconnectRos.bind(_assertThisInitialized(_this));
    _this.toggleAddModal = _this.toggleAddModal.bind(_assertThisInitialized(_this));
    _this.refreshRosData = _this.refreshRosData.bind(_assertThisInitialized(_this));
    _this.toggleConfigurationModal = _this.toggleConfigurationModal.bind(_assertThisInitialized(_this));
    _this.addVisualization = _this.addVisualization.bind(_assertThisInitialized(_this));
    _this.updateFramesList = _this.updateFramesList.bind(_assertThisInitialized(_this));
    _this.updateConfiguration = _this.updateConfiguration.bind(_assertThisInitialized(_this));
    _this.ros = new ROSLIB.Ros();
    _this.viewer = new Amphion.TfViewer(_this.ros, {
      onFramesListUpdate: _this.updateFramesList
    });
    return _this;
  }

  _createClass(Wrapper, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      var rosEndpoint = this.state.rosEndpoint;

      if (prevState.rosEndpoint !== rosEndpoint) {
        this.disconnectRos();
        this.connectRos();
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var rosEndpoint = this.state.rosEndpoint;
      this.ros.on('error', function () {
        _this2.setState({
          rosStatus: ROS_SOCKET_STATUSES.CONNECTION_ERROR
        });
      });
      this.ros.on('connection', this.refreshRosData);
      this.ros.on('close', function () {
        _this2.setState({
          rosStatus: ROS_SOCKET_STATUSES.INITIAL
        });
      });

      if (rosEndpoint) {
        this.connectRos();
      }
    }
  }, {
    key: "updateFramesList",
    value: function updateFramesList(framesList) {
      this.setState({
        framesList: _toConsumableArray(framesList)
      });
    }
  }, {
    key: "refreshRosData",
    value: function refreshRosData() {
      var _this3 = this;

      this.ros.getTopics(function (rosTopics) {
        _this3.setState({
          rosStatus: ROS_SOCKET_STATUSES.CONNECTED,
          rosTopics: _.map(rosTopics.topics, function (name, index) {
            return {
              name: name,
              messageType: rosTopics.types[index]
            };
          })
        });
      });
      this.ros.getParams(function (rosParams) {
        _this3.setState({
          rosParams: _.map(rosParams, function (p) {
            return _.trimStart(p, '/');
          })
        });
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.viewer.destroy();
    }
  }, {
    key: "connectRos",
    value: function connectRos() {
      var rosEndpoint = this.state.rosEndpoint;
      this.setState({
        rosStatus: ROS_SOCKET_STATUSES.CONNECTING
      });
      this.ros.connect(rosEndpoint);
    }
  }, {
    key: "disconnectRos",
    value: function disconnectRos() {
      if (this.ros && this.ros.close) {
        this.ros.close();
      }
    }
  }, {
    key: "toggleAddModal",
    value: function toggleAddModal() {
      var addModalOpen = this.state.addModalOpen;
      this.setState({
        addModalOpen: !addModalOpen
      });
    }
  }, {
    key: "toggleConfigurationModal",
    value: function toggleConfigurationModal() {
      var configurationModalOpen = this.state.configurationModalOpen;
      this.setState({
        configurationModalOpen: !configurationModalOpen
      });
    }
  }, {
    key: "addVisualization",
    value: function addVisualization(options) {
      var addVisualization = this.props.addVisualization;
      addVisualization(options);
      this.setState({
        addModalOpen: false
      });
    }
  }, {
    key: "updateConfiguration",
    value: function updateConfiguration(configuration) {
      var updateConfiguration = this.props.updateConfiguration;
      updateConfiguration(configuration);
      this.setState({
        configurationModalOpen: false
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$state = this.state,
          addModalOpen = _this$state.addModalOpen,
          configurationModalOpen = _this$state.configurationModalOpen,
          framesList = _this$state.framesList,
          rosEndpoint = _this$state.rosEndpoint,
          rosParams = _this$state.rosParams,
          rosStatus = _this$state.rosStatus,
          rosTopics = _this$state.rosTopics;
      var _this$props = this.props,
          _this$props$configura = _this$props.configuration,
          globalOptions = _this$props$configura.globalOptions,
          displaySidebar = _this$props$configura.panels.sidebar.display,
          visualizations = _this$props$configura.visualizations,
          configuration = _this$props.configuration,
          removeVisualization = _this$props.removeVisualization,
          toggleVisibility = _this$props.toggleVisibility,
          updateGlobalOptions = _this$props.updateGlobalOptions,
          updateRosEndpoint = _this$props.updateRosEndpoint,
          updateVizOptions = _this$props.updateVizOptions;
      return React.createElement(PanelWrapper, null, addModalOpen && React.createElement(AddModal, {
        ros: this.ros,
        rosTopics: rosTopics,
        rosParams: rosParams,
        closeModal: this.toggleAddModal,
        addVisualization: this.addVisualization
      }), configurationModalOpen && React.createElement(ConfigurationModal, {
        configuration: configuration,
        updateConfiguration: this.updateConfiguration,
        closeModal: this.toggleConfigurationModal
      }), displaySidebar && React.createElement(Sidebar, {
        framesList: framesList,
        globalOptions: globalOptions,
        rosEndpoint: rosEndpoint,
        rosInstance: this.ros,
        rosTopics: rosTopics,
        rosStatus: rosStatus,
        visualizations: visualizations,
        viewer: this.viewer,
        connectRos: this.connectRos,
        disconnectRos: this.disconnectRos,
        removeVisualization: removeVisualization,
        toggleAddModal: this.toggleAddModal,
        toggleVisibility: toggleVisibility,
        toggleConfigurationModal: this.toggleConfigurationModal,
        updateGlobalOptions: updateGlobalOptions,
        updateRosEndpoint: updateRosEndpoint,
        updateVizOptions: updateVizOptions
      }), React.createElement(PanelContent, null, React.createElement(Viewport, {
        viewer: this.viewer,
        globalOptions: globalOptions
      })), _.map(visualizations, function (vizItem) {
        return React.createElement(Visualization, {
          options: vizItem,
          key: vizItem.key,
          viewer: _this4.viewer,
          rosTopics: rosTopics,
          rosInstance: _this4.ros
        });
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(_ref) {
      var configuration = _ref.configuration;
      return {
        rosEndpoint: configuration.ros.endpoint
      };
    }
  }]);

  return Wrapper;
}(React.Component);

Wrapper.defaultProps = {
  configuration: DEFAULT_CONFIG
};
var Panels = withGracefulUnmount(Wrapper);

function ownKeys$g(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$g(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$g(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$g(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Zethus =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Zethus, _React$Component);

  function Zethus(props) {
    var _this;

    _classCallCheck(this, Zethus);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Zethus).call(this, props));
    var providedConfig = props.configuration || store.get('zethus_config') || {};
    _this.state = _objectSpread$g({}, _.merge({}, DEFAULT_CONFIG, providedConfig));
    _this.updateVizOptions = _this.updateVizOptions.bind(_assertThisInitialized(_this));
    _this.updateRosEndpoint = _this.updateRosEndpoint.bind(_assertThisInitialized(_this));
    _this.updateGlobalOptions = _this.updateGlobalOptions.bind(_assertThisInitialized(_this));
    _this.addVisualization = _this.addVisualization.bind(_assertThisInitialized(_this));
    _this.removeVisualization = _this.removeVisualization.bind(_assertThisInitialized(_this));
    _this.toggleVisibility = _this.toggleVisibility.bind(_assertThisInitialized(_this));
    _this.updateConfiguration = _this.updateConfiguration.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Zethus, [{
    key: "updateConfiguration",
    value: function updateConfiguration(configuration) {
      this.setState(_objectSpread$g({}, _.merge({}, DEFAULT_CONFIG, configuration)));
    }
  }, {
    key: "updateVizOptions",
    value: function updateVizOptions(key, options) {
      var visualizations = this.state.visualizations;
      this.setState({
        visualizations: _.map(visualizations, function (v) {
          return v.key === key ? _objectSpread$g({}, v, {}, options) : v;
        })
      });
    }
  }, {
    key: "updateRosEndpoint",
    value: function updateRosEndpoint(endpoint) {
      var ros = this.state.ros;
      this.setState({
        ros: _objectSpread$g({}, ros, {
          endpoint: endpoint
        })
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      store.set('zethus_config', this.state);
    }
  }, {
    key: "updateGlobalOptions",
    value: function updateGlobalOptions(path, option) {
      var globalOptions = this.state.globalOptions;

      var clonedGlobalOptions = _.cloneDeep(globalOptions);

      _.set(clonedGlobalOptions, path, option);

      this.setState({
        globalOptions: clonedGlobalOptions
      });
    }
  }, {
    key: "removeVisualization",
    value: function removeVisualization(e) {
      var vizId = e.target.dataset.id;
      var visualizations = this.state.visualizations;
      this.setState({
        visualizations: _.filter(visualizations, function (v) {
          return v.key !== vizId;
        })
      });
    }
  }, {
    key: "toggleVisibility",
    value: function toggleVisibility(e) {
      var vizId = e.target.dataset.id;
      var visualizations = this.state.visualizations;
      this.setState({
        visualizations: _.map(visualizations, function (v) {
          return v.key === vizId ? _objectSpread$g({}, v, {
            visible: !!(_.isBoolean(v.visible) && !v.visible)
          }) : v;
        })
      });
    }
  }, {
    key: "addVisualization",
    value: function addVisualization(vizOptions) {
      var visualizations = this.state.visualizations;
      this.setState({
        visualizations: [].concat(_toConsumableArray(visualizations), [_objectSpread$g({}, vizOptions, {
          key: shortid.generate()
        })])
      });
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement(Panels, {
        configuration: this.state,
        addVisualization: this.addVisualization,
        removeVisualization: this.removeVisualization,
        toggleVisibility: this.toggleVisibility,
        updateConfiguration: this.updateConfiguration,
        updateVizOptions: this.updateVizOptions,
        updateRosEndpoint: this.updateRosEndpoint,
        updateGlobalOptions: this.updateGlobalOptions
      });
    }
  }]);

  return Zethus;
}(React.Component);

withGracefulUnmount(Zethus);
ct__default.PureComponent);

  function _templateObject$5() {
    var data = _taggedTemplateLiteral(["\n  flex-grow: 1;\n  flex-shrink: 1;\n  background-color: ", ";\n  .jsoneditor-menu {\n    background-color: ", ";\n    border-bottom: 0;\n    border-radius: 4px 4px 0 0;\n    & > button {\n      color: ", ";\n    }\n  }\n  .jsoneditor {\n    border: 1px solid ", ";\n    border-radius: 4px;\n  }\n  .ace_editor {\n    font-family: 'Source Code Pro', sans-serif;\n  }\n  .jsoneditor-text {\n    background-color: ", ";\n  }\n  .jsoneditor-statusbar {\n    border-radius: 0 0 4px 4px;\n  }\n"]);

    _templateObject$5 = function _templateObject() {
      return data;
    };

    return data;
  }
  var StyledEditor = styled__default.div(_templateObject$5(), COLOR_GREY_LIGHT_1, COLOR_GREY_LIGHT_2, COLOR_PRIMARY, COLOR_GREY_LIGHT_2, COLOR_GREY_LIGHT_1);

  var ConfigurationModal =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(ConfigurationModal, _React$Component);

    function ConfigurationModal(props) {
      var _this;

      _classCallCheck(this, ConfigurationModal);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(ConfigurationModal).call(this, props));
      _this.state = {
        config: props.configuration
      };
      _this.handleChange = _this.handleChange.bind(_assertThisInitialized(_this));
      _this.handleSubmit = _this.handleSubmit.bind(_assertThisInitialized(_this));
      return _this;
    }

    _createClass(ConfigurationModal, [{
      key: "handleChange",
      value: function handleChange(config) {
        this.setState({
          config: config
        });
      }
    }, {
      key: "handleSubmit",
      value: function handleSubmit() {
        var updateConfiguration = this.props.updateConfiguration;
        var config = this.state.config;
        updateConfiguration(config);
      }
    }, {
      key: "render",
      value: function render() {
        var closeModal = this.props.closeModal;
        var config = this.state.config;
        return React__default.createElement(ModalWrapper, {
          onClick: closeModal
        }, React__default.createElement(ModalContents, {
          onClick: stopPropagation
        }, React__default.createElement(ModalTitle, null, "Edit Configuration"), React__default.createElement(jsoneditorReact.JsonEditor, {
          ace: ace,
          mode: "code",
          value: config,
          onChange: this.handleChange,
          tag: StyledEditor,
          theme: "ace/theme/xcode"
        }), React__default.createElement(ModalActions, null, React__default.createElement(FlexGrow, null), React__default.createElement(ButtonPrimary, {
          onClick: this.handleSubmit
        }, "Update Configuration"), React__default.createElement(ButtonPrimary, {
          onClick: closeModal
        }, "Cancel"))));
      }
    }]);

    return ConfigurationModal;
  }(React__default.Component);

  var Wrapper =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(Wrapper, _React$Component);

    function Wrapper(props) {
      var _this;

      _classCallCheck(this, Wrapper);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(Wrapper).call(this, props));
      _this.state = {
        rosEndpoint: '',
        rosStatus: ROS_SOCKET_STATUSES.INITIAL,
        addModalOpen: false,
        configurationModalOpen: false,
        rosTopics: [],
        rosParams: [],
        framesList: []
      };
      _this.connectRos = _this.connectRos.bind(_assertThisInitialized(_this));
      _this.disconnectRos = _this.disconnectRos.bind(_assertThisInitialized(_this));
      _this.toggleAddModal = _this.toggleAddModal.bind(_assertThisInitialized(_this));
      _this.refreshRosData = _this.refreshRosData.bind(_assertThisInitialized(_this));
      _this.toggleConfigurationModal = _this.toggleConfigurationModal.bind(_assertThisInitialized(_this));
      _this.addVisualization = _this.addVisualization.bind(_assertThisInitialized(_this));
      _this.updateFramesList = _this.updateFramesList.bind(_assertThisInitialized(_this));
      _this.updateConfiguration = _this.updateConfiguration.bind(_assertThisInitialized(_this));
      _this.ros = new ROSLIB.Ros();
      _this.viewer = new Amphion.TfViewer(_this.ros, {
        onFramesListUpdate: _this.updateFramesList
      });
      return _this;
    }

    _createClass(Wrapper, [{
      key: "componentDidUpdate",
      value: function componentDidUpdate(prevProps, prevState) {
        var rosEndpoint = this.state.rosEndpoint;

        if (prevState.rosEndpoint !== rosEndpoint) {
          this.disconnectRos();
          this.connectRos();
        }
      }
    }, {
      key: "componentDidMount",
      value: function componentDidMount() {
        var _this2 = this;

        var rosEndpoint = this.state.rosEndpoint;
        this.ros.on('error', function () {
          _this2.setState({
            rosStatus: ROS_SOCKET_STATUSES.CONNECTION_ERROR
          });
        });
        this.ros.on('connection', this.refreshRosData);
        this.ros.on('close', function () {
          _this2.setState({
            rosStatus: ROS_SOCKET_STATUSES.INITIAL
          });
        });

        if (rosEndpoint) {
          this.connectRos();
        }
      }
    }, {
      key: "updateFramesList",
      value: function updateFramesList(framesList) {
        this.setState({
          framesList: _toConsumableArray(framesList)
        });
      }
    }, {
      key: "refreshRosData",
      value: function refreshRosData() {
        var _this3 = this;

        this.ros.getTopics(function (rosTopics) {
          _this3.setState({
            rosStatus: ROS_SOCKET_STATUSES.CONNECTED,
            rosTopics: ___default.map(rosTopics.topics, function (name, index) {
              return {
                name: name,
                messageType: rosTopics.types[index]
              };
            })
          });
        });
        this.ros.getParams(function (rosParams) {
          _this3.setState({
            rosParams: ___default.map(rosParams, function (p) {
              return ___default.trimStart(p, '/');
            })
          });
        });
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this.viewer.destroy();
      }
    }, {
      key: "connectRos",
      value: function connectRos() {
        var rosEndpoint = this.state.rosEndpoint;
        this.setState({
          rosStatus: ROS_SOCKET_STATUSES.CONNECTING
        });
        this.ros.connect(rosEndpoint);
      }
    }, {
      key: "disconnectRos",
      value: function disconnectRos() {
        if (this.ros && this.ros.close) {
          this.ros.close();
        }
      }
    }, {
      key: "toggleAddModal",
      value: function toggleAddModal() {
        var addModalOpen = this.state.addModalOpen;
        this.setState({
          addModalOpen: !addModalOpen
        });
      }
    }, {
      key: "toggleConfigurationModal",
      value: function toggleConfigurationModal() {
        var configurationModalOpen = this.state.configurationModalOpen;
        this.setState({
          configurationModalOpen: !configurationModalOpen
        });
      }
    }, {
      key: "addVisualization",
      value: function addVisualization(options) {
        var addVisualization = this.props.addVisualization;
        addVisualization(options);
        this.setState({
          addModalOpen: false
        });
      }
    }, {
      key: "updateConfiguration",
      value: function updateConfiguration(configuration) {
        var updateConfiguration = this.props.updateConfiguration;
        updateConfiguration(configuration);
        this.setState({
          configurationModalOpen: false
        });
      }
    }, {
      key: "render",
      value: function render() {
        var _this4 = this;

        var _this$state = this.state,
            addModalOpen = _this$state.addModalOpen,
            configurationModalOpen = _this$state.configurationModalOpen,
            framesList = _this$state.framesList,
            rosEndpoint = _this$state.rosEndpoint,
            rosParams = _this$state.rosParams,
            rosStatus = _this$state.rosStatus,
            rosTopics = _this$state.rosTopics;
        var _this$props = this.props,
            _this$props$configura = _this$props.configuration,
            globalOptions = _this$props$configura.globalOptions,
            displaySidebar = _this$props$configura.panels.sidebar.display,
            visualizations = _this$props$configura.visualizations,
            configuration = _this$props.configuration,
            removeVisualization = _this$props.removeVisualization,
            toggleVisibility = _this$props.toggleVisibility,
            updateGlobalOptions = _this$props.updateGlobalOptions,
            updateRosEndpoint = _this$props.updateRosEndpoint,
            updateVizOptions = _this$props.updateVizOptions;
        return React__default.createElement(PanelWrapper, null, addModalOpen && React__default.createElement(AddModal, {
          ros: this.ros,
          rosTopics: rosTopics,
          rosParams: rosParams,
          closeModal: this.toggleAddModal,
          addVisualization: this.addVisualization
        }), configurationModalOpen && React__default.createElement(ConfigurationModal, {
          configuration: configuration,
          updateConfiguration: this.updateConfiguration,
          closeModal: this.toggleConfigurationModal
        }), displaySidebar && React__default.createElement(Sidebar, {
          framesList: framesList,
          globalOptions: globalOptions,
          rosEndpoint: rosEndpoint,
          rosInstance: this.ros,
          rosTopics: rosTopics,
          rosStatus: rosStatus,
          visualizations: visualizations,
          viewer: this.viewer,
          connectRos: this.connectRos,
          disconnectRos: this.disconnectRos,
          removeVisualization: removeVisualization,
          toggleAddModal: this.toggleAddModal,
          toggleVisibility: toggleVisibility,
          toggleConfigurationModal: this.toggleConfigurationModal,
          updateGlobalOptions: updateGlobalOptions,
          updateRosEndpoint: updateRosEndpoint,
          updateVizOptions: updateVizOptions
        }), React__default.createElement(PanelContent, null, React__default.createElement(Viewport, {
          viewer: this.viewer,
          globalOptions: globalOptions
        })), ___default.map(visualizations, function (vizItem) {
          return React__default.createElement(Visualization, {
            options: vizItem,
            key: vizItem.key,
            viewer: _this4.viewer,
            rosTopics: rosTopics,
            rosInstance: _this4.ros
          });
        }));
      }
    }], [{
      key: "getDerivedStateFromProps",
      value: function getDerivedStateFromProps(_ref) {
        var configuration = _ref.configuration;
        return {
          rosEndpoint: configuration.ros.endpoint
        };
      }
    }]);

    return Wrapper;
  }(React__default.Component);

  Wrapper.defaultProps = {
    configuration: DEFAULT_CONFIG
  };
  var Panels = withGracefulUnmount(Wrapper);

  function ownKeys$g(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread$g(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$g(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$g(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  var Zethus =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(Zethus, _React$Component);

    function Zethus(props) {
      var _this;

      _classCallCheck(this, Zethus);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(Zethus).call(this, props));
      var providedConfig = props.configuration || store.get('zethus_config') || {};
      _this.state = _objectSpread$g({}, ___default.merge({}, DEFAULT_CONFIG, providedConfig));
      _this.updateVizOptions = _this.updateVizOptions.bind(_assertThisInitialized(_this));
      _this.updateRosEndpoint = _this.updateRosEndpoint.bind(_assertThisInitialized(_this));
      _this.updateGlobalOptions = _this.updateGlobalOptions.bind(_assertThisInitialized(_this));
      _this.addVisualization = _this.addVisualization.bind(_assertThisInitialized(_this));
      _this.removeVisualization = _this.removeVisualization.bind(_assertThisInitialized(_this));
      _this.toggleVisibility = _this.toggleVisibility.bind(_assertThisInitialized(_this));
      _this.updateConfiguration = _this.updateConfiguration.bind(_assertThisInitialized(_this));
      return _this;
    }

    _createClass(Zethus, [{
      key: "updateConfiguration",
      value: function updateConfiguration(configuration) {
        this.setState(_objectSpread$g({}, ___default.merge({}, DEFAULT_CONFIG, configuration)));
      }
    }, {
      key: "updateVizOptions",
      value: function updateVizOptions(key, options) {
        var visualizations = this.state.visualizations;
        this.setState({
          visualizations: ___default.map(visualizations, function (v) {
            return v.key === key ? _objectSpread$g({}, v, {}, options) : v;
          })
        });
      }
    }, {
      key: "updateRosEndpoint",
      value: function updateRosEndpoint(endpoint) {
        var ros = this.state.ros;
        this.setState({
          ros: _objectSpread$g({}, ros, {
            endpoint: endpoint
          })
        });
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        store.set('zethus_config', this.state);
      }
    }, {
      key: "updateGlobalOptions",
      value: function updateGlobalOptions(path, option) {
        var globalOptions = this.state.globalOptions;

        var clonedGlobalOptions = ___default.cloneDeep(globalOptions);

        ___default.set(clonedGlobalOptions, path, option);

        this.setState({
          globalOptions: clonedGlobalOptions
        });
      }
    }, {
      key: "removeVisualization",
      value: function removeVisualization(e) {
        var vizId = e.target.dataset.id;
        var visualizations = this.state.visualizations;
        this.setState({
          visualizations: ___default.filter(visualizations, function (v) {
            return v.key !== vizId;
          })
        });
      }
    }, {
      key: "toggleVisibility",
      value: function toggleVisibility(e) {
        var vizId = e.target.dataset.id;
        var visualizations = this.state.visualizations;
        this.setState({
          visualizations: ___default.map(visualizations, function (v) {
            return v.key === vizId ? _objectSpread$g({}, v, {
              visible: !!(___default.isBoolean(v.visible) && !v.visible)
            }) : v;
          })
        });
      }
    }, {
      key: "addVisualization",
      value: function addVisualization(vizOptions) {
        var visualizations = this.state.visualizations;
        this.setState({
          visualizations: [].concat(_toConsumableArray(visualizations), [_objectSpread$g({}, vizOptions, {
            key: shortid.generate()
          })])
        });
      }
    }, {
      key: "render",
      value: function render() {
        return React__default.createElement(Panels, {
          configuration: this.state,
          addVisualization: this.addVisualization,
          removeVisualization: this.removeVisualization,
          toggleVisibility: this.toggleVisibility,
          updateConfiguration: this.updateConfiguration,
          updateVizOptions: this.updateVizOptions,
          updateRosEndpoint: this.updateRosEndpoint,
          updateGlobalOptions: this.updateGlobalOptions
        });
      }
    }]);

    return Zethus;
  }(React__default.Component);

  withGracefulUnmount(Zethus);

})));
//# sourceMappingURL=_rollup-plugin-multi-entry:entry-point.js.map
